﻿' MIT - Licence
'
' Copyright (c) 2010 - 2011 Nils Schmidt
' This program uses Rectifier.exe by permission of the author and copyright holder Philippe E. Hurbain - (C) 2009

' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
' to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
' and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

' The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
' PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
' FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
' ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Option Strict Off
Imports System.Windows.Forms
Imports System.IO
Imports System.Runtime.InteropServices

Public Class BitmapDialog
    Dim free As Integer = 239


    <StructLayout(LayoutKind.Explicit)> _
    Structure _WORD
        <FieldOffset(0)> Dim Value As UInt16
        <FieldOffset(0)> Dim lower As Byte
        <FieldOffset(1)> Dim upper As Byte
    End Structure

    <StructLayout(LayoutKind.Explicit)> _
    Structure _DWORD
        <FieldOffset(0)> Dim Value As UInt32
        <FieldOffset(0)> Dim lowest As Byte
        <FieldOffset(1)> Dim lower As Byte
        <FieldOffset(2)> Dim upper As Byte
        <FieldOffset(3)> Dim upmost As Byte
    End Structure

    <StructLayout(LayoutKind.Explicit)> _
    Structure _LONG
        <FieldOffset(0)> Dim Value As Int32
        <FieldOffset(0)> Dim lowest As Byte
        <FieldOffset(1)> Dim lower As Byte
        <FieldOffset(2)> Dim upper As Byte
        <FieldOffset(3)> Dim upmost As Byte
    End Structure


    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        If SaveBitmap.ShowDialog = Windows.Forms.DialogResult.OK AndAlso SaveBitmap.FileName <> "" Then
            Try
                Dim ncolours As _DWORD
                ncolours.Value = Me.Controls("GBBitmap").Controls("ColoursUsed").Controls.Count
                Dim offset As _DWORD
                Dim size As _DWORD
                Dim height As _LONG
                Dim width As _LONG
                Dim raw_data_size As _DWORD
                offset.Value = 54 + 4 * ncolours.Value
                raw_data_size.Value = CType(NUDHeight.Value, Integer) * (CType(NUDWidth.Value, Integer) + CType(NUDWidth.Value, Integer) Mod 4)
                size.Value = offset.Value + raw_data_size.Value
                height.Value = CType(NUDHeight.Value, Integer)
                width.Value = CType(NUDWidth.Value, Integer)
                Using DateiOut As BinaryWriter = New BinaryWriter(File.Open(SaveBitmap.FileName, FileMode.Create))

                    ' Header:
                    For Each c As Char In "BM".ToCharArray
                        DateiOut.Write(c)
                    Next

                    DateiOut.Write(CType(size.lowest, Byte))
                    DateiOut.Write(CType(size.lower, Byte))
                    DateiOut.Write(CType(size.upper, Byte))
                    DateiOut.Write(CType(size.upmost, Byte))

                    DateiOut.Write(CType(&H0, Byte))
                    DateiOut.Write(CType(&H0, Byte))
                    DateiOut.Write(CType(&H0, Byte))
                    DateiOut.Write(CType(&H0, Byte))

                    DateiOut.Write(CType(offset.lowest, Byte))
                    DateiOut.Write(CType(offset.lower, Byte))
                    DateiOut.Write(CType(offset.upper, Byte))
                    DateiOut.Write(CType(offset.upmost, Byte))

                    ' DIB - Header:
                    DateiOut.Write(CType(&H28, Byte))
                    DateiOut.Write(CType(&H0, Byte))
                    DateiOut.Write(CType(&H0, Byte))
                    DateiOut.Write(CType(&H0, Byte))

                    DateiOut.Write(CType(width.lowest, Byte))
                    DateiOut.Write(CType(width.lower, Byte))
                    DateiOut.Write(CType(width.upper, Byte))
                    DateiOut.Write(CType(width.upmost, Byte))

                    DateiOut.Write(CType(height.lowest, Byte))
                    DateiOut.Write(CType(height.lower, Byte))
                    DateiOut.Write(CType(height.upper, Byte))
                    DateiOut.Write(CType(height.upmost, Byte))

                    DateiOut.Write(CType(&H1, Byte))
                    DateiOut.Write(CType(&H0, Byte))

                    DateiOut.Write(CType(&H8, Byte))
                    DateiOut.Write(CType(&H0, Byte))

                    DateiOut.Write(CType(&H0, Byte))
                    DateiOut.Write(CType(&H0, Byte))
                    DateiOut.Write(CType(&H0, Byte))
                    DateiOut.Write(CType(&H0, Byte))

                    DateiOut.Write(CType(raw_data_size.lowest, Byte))
                    DateiOut.Write(CType(raw_data_size.lower, Byte))
                    DateiOut.Write(CType(raw_data_size.upper, Byte))
                    DateiOut.Write(CType(raw_data_size.upmost, Byte))

                    DateiOut.Write(CType(&H0, Int32))
                    DateiOut.Write(CType(&H0, Int32))

                    DateiOut.Write(CType(ncolours.lowest, Byte))
                    DateiOut.Write(CType(ncolours.lower, Byte))
                    DateiOut.Write(CType(ncolours.upper, Byte))
                    DateiOut.Write(CType(ncolours.upmost, Byte))

                    DateiOut.Write(CType(&H0, Int32))
                    ' Farbtabelle:
                    For i As Integer = 0 To ncolours.Value - 1
                        Dim co As Color = Me.Controls("GBBitmap").Controls("ColoursUsed").Controls.Item(i).BackColor
                        DateiOut.Write(CType(co.B, Byte))
                        DateiOut.Write(CType(co.G, Byte))
                        DateiOut.Write(CType(co.R, Byte))
                        DateiOut.Write(CType(&H0, Byte))
                    Next

                    ' Pixel-Data:
                    For y As Integer = 1 To CType(NUDHeight.Value, Integer)
                        For x As Integer = 1 To CType(NUDWidth.Value, Integer) + CType(NUDWidth.Value, Integer) Mod 4
                            DateiOut.Write(CType(0, Byte))
                        Next
                    Next
                End Using
            Catch
            End Try
        End If
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()

    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub BitmapDialog_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Buttons anlegen
        Me.Controls("GBAll").Controls("ColoursAvailable").Controls.Clear()
        Me.Controls("GBBitmap").Controls("ColoursUsed").Controls.Clear()
        For i As Integer = 0 To MainForm.maxColourNumber
            If MainForm.colourHMap.ContainsKey(i) Then
                Dim btn As New Button
                btn.Height = 25
                btn.Width = 25
                ToolTip1.SetToolTip(btn, "Colour " & i & ": " & MainForm.colourHMapName(i))
                btn.Name = "btn" & i
                If i <> 16 Then
                    btn.BackColor = MainForm.colourHMap(i)
                Else
                    btn.BackColor = Color.FromArgb(0, 255, 111, 255)
                End If
                btn.Tag = i
                btn.FlatStyle = FlatStyle.Flat
                If i > 16 Then
                    Me.Controls("GBAll").Controls("ColoursAvailable").Controls.Add(btn)
                Else
                    Me.Controls("GBBitmap").Controls("ColoursUsed").Controls.Add(btn)
                End If
                AddHandler btn.Click, AddressOf btn_click
            End If
        Next
        free = 239
        OK_Button.Enabled = True
    End Sub

    Private Sub btn_click(ByVal sender As Button, ByVal e As EventArgs)
        If sender.Parent.Name = "ColoursAvailable" Then
            If free > 0 Then
                free -= 1
                Me.Controls("GBBitmap").Controls("ColoursUsed").Controls.Add(sender)
            End If
        Else
            free += 1
            Me.Controls("GBAll").Controls("ColoursAvailable").Controls.Add(sender)
        End If
        LblFree.Text = "Free: " & free
        OK_Button.Enabled = free < 256
    End Sub

End Class

'protected int FindClosest(Color c) 
'361          {
'362              if (colorTab == null) return -1;
'363              int r = c.R;
'364              int g = c.G;
'365              int b = c.B;
'366              int minpos = 0;
'367              int dmin = 256 * 256 * 256;
'368              int len = colorTab.Length;
'369              for (int i = 0; i < len;) 
'370              {
'371                  int dr = r - (colorTab[i++] & 0xff);
'372                  int dg = g - (colorTab[i++] & 0xff);
'373                  int db = b - (colorTab[i] & 0xff);
'374                  int d = dr * dr + dg * dg + db * db;
'375                  int index = i / 3;
'376                  if (usedEntry[index] && (d < dmin)) 
'377                  {
'378                      dmin = d;
'379                      minpos = index;
'380                  }
'381                  i++;
'382              }
'383              return minpos;
'384          }
