﻿Option Strict Off
Module CSG


    Public beamdir() As Decimal = {0, 0, -1}
    Public beamorig(2) As Decimal

    Public schnittpunkt As New MainForm.Vertex(0, 0, False, False)


    Public Sub subdivideTriangle(ByRef tri As MainForm.Triangle)
        tri.normalize()
        tri.checkWinding()
        Dim tvA As MainForm.Vertex = tri.vertexA
        Dim tvB As MainForm.Vertex = tri.vertexB
        Dim tvC As MainForm.Vertex = tri.vertexC

        MainForm.SelectedTriangles.Remove(tri)
        MainForm.removeTriangle(tri)

        Dim center1 As New MainForm.Vertex((tvA.X + tvB.X) / 2, (tvA.Y + tvB.Y) / 2, False)
        MainForm.Vertices.Add(center1)
        Dim center2 As New MainForm.Vertex((tvB.X + tvC.X) / 2, (tvB.Y + tvC.Y) / 2, False)
        MainForm.Vertices.Add(center2)
        Dim center3 As New MainForm.Vertex((tvC.X + tvA.X) / 2, (tvC.Y + tvA.Y) / 2, False)
        MainForm.Vertices.Add(center3)

        MainForm.Triangles.Add(New MainForm.Triangle(center1, center2, center3) With {.myColour = tri.myColour, .myColourNumber = tri.myColourNumber})
        center1.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
        center2.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
        center3.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
        MainForm.SelectedTriangles.Add(MainForm.LLast(MainForm.Triangles))

        MainForm.SelectedVertices.Clear()
        MainForm.SelectedVertices.Add(tvA)
        MainForm.SelectedVertices.Add(tvB)
        splitTriangle(tvA, tvB)
        MainForm.SelectedVertices.Clear()
        MainForm.SelectedVertices.Add(tvB)
        MainForm.SelectedVertices.Add(tvC)
        splitTriangle(tvB, tvC)
        MainForm.SelectedVertices.Clear()
        MainForm.SelectedVertices.Add(tvC)
        MainForm.SelectedVertices.Add(tvA)
        splitTriangle(tvC, tvA)

        MainForm.Triangles.Add(New MainForm.Triangle(center1, center2, tvB) With {.myColour = tri.myColour, .myColourNumber = tri.myColourNumber})
        center1.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
        center2.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
        tvB.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))

        MainForm.Triangles.Add(New MainForm.Triangle(center2, center3, tvC) With {.myColour = tri.myColour, .myColourNumber = tri.myColourNumber})
        center2.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
        center3.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
        tvC.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))

        MainForm.Triangles.Add(New MainForm.Triangle(center3, center1, tvA) With {.myColour = tri.myColour, .myColourNumber = tri.myColourNumber})
        center3.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
        center1.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
        tvA.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
    End Sub

    Public Sub splitTriangle(ByRef v1 As MainForm.Vertex, ByRef v2 As MainForm.Vertex)
        Dim tri1 As MainForm.Triangle = Nothing
        Dim tri2 As MainForm.Triangle = Nothing
        Do
            For i As Integer = 0 To MainForm.SelectedVertices(0).linkedTriangles.Count - 1
                For j As Integer = 0 To MainForm.SelectedVertices(1).linkedTriangles.Count - 1
                    If MainForm.SelectedVertices(0).linkedTriangles(i).triangleID = MainForm.SelectedVertices(1).linkedTriangles(j).triangleID Then
                        If tri1 Is Nothing Then
                            tri1 = MainForm.SelectedVertices(0).linkedTriangles(i)
                        ElseIf tri2 Is Nothing Then
                            tri2 = MainForm.SelectedVertices(0).linkedTriangles(i)
                        End If
                        If Not tri1 Is Nothing AndAlso Not tri2 Is Nothing Then Exit Do
                    End If
                Next
            Next
            Exit Do
        Loop
        If Not tri1 Is Nothing AndAlso Not tri2 Is Nothing Then
            Dim center As New MainForm.Vertex((v1.X + v2.X) / 2, (v1.Y + v2.Y) / 2, False)
            MainForm.Vertices.Add(center)
            Dim tv1 As MainForm.Vertex = Nothing
            If v1.vertexID = tri1.vertexA.vertexID Then
                If v2.vertexID = tri1.vertexB.vertexID Then
                    tv1 = tri1.vertexC
                ElseIf v2.vertexID = tri1.vertexC.vertexID Then
                    tv1 = tri1.vertexB
                End If
            ElseIf v1.vertexID = tri1.vertexB.vertexID Then
                If v2.vertexID = tri1.vertexA.vertexID Then
                    tv1 = tri1.vertexC
                ElseIf v2.vertexID = tri1.vertexC.vertexID Then
                    tv1 = tri1.vertexA
                End If
            ElseIf v1.vertexID = tri1.vertexC.vertexID Then
                If v2.vertexID = tri1.vertexB.vertexID Then
                    tv1 = tri1.vertexA
                ElseIf v2.vertexID = tri1.vertexA.vertexID Then
                    tv1 = tri1.vertexB
                End If
            End If
            Dim tv2 As MainForm.Vertex = Nothing
            If v1.vertexID = tri2.vertexA.vertexID Then
                If v2.vertexID = tri2.vertexB.vertexID Then
                    tv2 = tri2.vertexC
                ElseIf v2.vertexID = tri2.vertexC.vertexID Then
                    tv2 = tri2.vertexB
                End If
            ElseIf v1.vertexID = tri2.vertexB.vertexID Then
                If v2.vertexID = tri2.vertexA.vertexID Then
                    tv2 = tri2.vertexC
                ElseIf v2.vertexID = tri2.vertexC.vertexID Then
                    tv2 = tri2.vertexA
                End If
            ElseIf v1.vertexID = tri2.vertexC.vertexID Then
                If v2.vertexID = tri2.vertexB.vertexID Then
                    tv2 = tri2.vertexA
                ElseIf v2.vertexID = tri2.vertexA.vertexID Then
                    tv2 = tri2.vertexB
                End If
            End If
            MainForm.Triangles.Add(New MainForm.Triangle(v1, tv1, center) With {.myColour = tri1.myColour, .myColourNumber = tri1.myColourNumber})
            MainForm.LLast(MainForm.Vertices).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            v1.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            tv1.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            MainForm.Triangles.Add(New MainForm.Triangle(v2, tv1, center) With {.myColour = tri1.myColour, .myColourNumber = tri1.myColourNumber})
            MainForm.LLast(MainForm.Vertices).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            v2.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            tv1.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            MainForm.Triangles.Add(New MainForm.Triangle(v1, tv2, center) With {.myColour = tri2.myColour, .myColourNumber = tri2.myColourNumber})
            MainForm.LLast(MainForm.Vertices).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            v1.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            tv2.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            MainForm.Triangles.Add(New MainForm.Triangle(v2, tv2, center) With {.myColour = tri2.myColour, .myColourNumber = tri2.myColourNumber})
            MainForm.LLast(MainForm.Vertices).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            v2.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            tv2.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            MainForm.removeTriangle(tri1)
            MainForm.removeTriangle(tri2)
        ElseIf Not tri1 Is Nothing Then
            Dim center As New MainForm.Vertex((v1.X + v2.X) / 2, (v1.Y + v2.Y) / 2, False)
            MainForm.Vertices.Add(center)
            Dim tv1 As MainForm.Vertex = Nothing
            If v1.vertexID = tri1.vertexA.vertexID Then
                If v2.vertexID = tri1.vertexB.vertexID Then
                    tv1 = tri1.vertexC
                ElseIf v2.vertexID = tri1.vertexC.vertexID Then
                    tv1 = tri1.vertexB
                End If
            ElseIf v1.vertexID = tri1.vertexB.vertexID Then
                If v2.vertexID = tri1.vertexA.vertexID Then
                    tv1 = tri1.vertexC
                ElseIf v2.vertexID = tri1.vertexC.vertexID Then
                    tv1 = tri1.vertexA
                End If
            ElseIf v1.vertexID = tri1.vertexC.vertexID Then
                If v2.vertexID = tri1.vertexB.vertexID Then
                    tv1 = tri1.vertexA
                ElseIf v2.vertexID = tri1.vertexA.vertexID Then
                    tv1 = tri1.vertexB
                End If
            End If
            MainForm.Triangles.Add(New MainForm.Triangle(v1, tv1, center) With {.myColour = tri1.myColour, .myColourNumber = tri1.myColourNumber})
            MainForm.LLast(MainForm.Vertices).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            v1.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            tv1.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            MainForm.Triangles.Add(New MainForm.Triangle(v2, tv1, center) With {.myColour = tri1.myColour, .myColourNumber = tri1.myColourNumber})
            MainForm.LLast(MainForm.Vertices).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            v2.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            tv1.linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
            MainForm.removeTriangle(tri1)
        End If
    End Sub

    Public Function intersectionBetweenTwoLines(ByRef v11 As MainForm.Vertex, ByRef v12 As MainForm.Vertex, ByRef v21 As MainForm.Vertex, ByRef v22 As MainForm.Vertex) As MainForm.Vertex
        If (v11.X = v21.X AndAlso v11.Y = v21.Y) OrElse (v12.X = v22.X AndAlso v12.Y = v22.Y) Then Return Nothing
        If (v11.X = v22.X AndAlso v11.Y = v22.Y) OrElse (v12.X = v21.X AndAlso v12.Y = v21.Y) Then Return Nothing

        Dim za1, za2, zb1, zb2, zc1, zc2 As Single
        Dim sx, sy As Single

        za1 = v12.Y - v11.Y
        za2 = v22.Y - v21.Y
        zb1 = v11.X - v12.X
        zb2 = v21.X - v22.X
        zc1 = za1 * v11.X + zb1 * v11.Y
        zc2 = za2 * v21.X + zb2 * v21.Y

        sx = (zc1 * zb2 - zc2 * zb1) / (za1 * zb2 - za2 * zb1)
        sy = (za1 * zc2 - za2 * zc1) / (za1 * zb2 - za2 * zb1)

        If Single.IsNaN(sx) OrElse Single.IsNaN(sy) Then Return Nothing

        If sy > v11.Y AndAlso sy > v12.Y Then Return Nothing
        If sy > v21.Y AndAlso sy > v22.Y Then Return Nothing
        If sy < v11.Y AndAlso sy < v12.Y Then Return Nothing
        If sy < v21.Y AndAlso sy < v22.Y Then Return Nothing

        If sx > v11.X AndAlso sx > v12.X Then Return Nothing
        If sx > v21.X AndAlso sx > v22.X Then Return Nothing
        If sx < v11.X AndAlso sx < v12.X Then Return Nothing
        If sx < v21.X AndAlso sx < v22.X Then Return Nothing

        Return New MainForm.Vertex(sx, sy, False, False)
    End Function

    Public Function CSG2Triangles(ByRef tri1 As MainForm.Triangle, ByRef tri2 As MainForm.Triangle) As Boolean

        Dim verticesIntersections As New List(Of MainForm.Vertex)
        Dim verticesInner As New List(Of MainForm.Vertex)
        Dim verticesOuter As New List(Of MainForm.Vertex)
        Dim verticesComplete As New List(Of MainForm.Vertex)


        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexA, tri1.vertexB, tri2.vertexA, tri2.vertexB)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexA, tri1.vertexB, tri2.vertexB, tri2.vertexC)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexA, tri1.vertexB, tri2.vertexC, tri2.vertexA)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False))

        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexB, tri1.vertexC, tri2.vertexA, tri2.vertexB)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexB, tri1.vertexC, tri2.vertexB, tri2.vertexC)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexB, tri1.vertexC, tri2.vertexC, tri2.vertexA)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False))

        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexC, tri1.vertexA, tri2.vertexA, tri2.vertexB)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexC, tri1.vertexA, tri2.vertexB, tri2.vertexC)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexC, tri1.vertexA, tri2.vertexC, tri2.vertexA)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False))

        ' Bestimme innere Punkte:

        Dim vert0(2) As Decimal
        Dim vert1(2) As Decimal
        Dim vert2(2) As Decimal
        vert0(2) = 0 : vert1(2) = 0 : vert2(2) = 0 : beamorig(2) = 1
        ' -> Test auf Dreieck 1
        vert0(0) = tri1.vertexA.X
        vert0(1) = tri1.vertexA.Y
        vert1(0) = tri1.vertexB.X
        vert1(1) = tri1.vertexB.Y
        vert2(0) = tri1.vertexC.X
        vert2(1) = tri1.vertexC.Y
        If tri2.vertexA <> tri1.vertexA AndAlso tri2.vertexA <> tri1.vertexB AndAlso tri2.vertexA <> tri1.vertexC Then
            beamorig(0) = tri2.vertexA.X : beamorig(1) = tri2.vertexA.Y
            If PowerRay.SCHNITTPKT_DREIECK(beamorig, beamdir, vert0, vert1, vert2) Then
                verticesInner.Add(tri2.vertexA)
                tri2.vertexA.selected = True
            End If
        End If
        If tri2.vertexB <> tri1.vertexA AndAlso tri2.vertexB <> tri1.vertexB AndAlso tri2.vertexB <> tri1.vertexC Then
            beamorig(0) = tri2.vertexB.X : beamorig(1) = tri2.vertexB.Y
            If PowerRay.SCHNITTPKT_DREIECK(beamorig, beamdir, vert0, vert1, vert2) Then
                verticesInner.Add(tri2.vertexB)
                tri2.vertexB.selected = True
            End If
        End If
        If tri2.vertexC <> tri1.vertexA AndAlso tri2.vertexC <> tri1.vertexB AndAlso tri2.vertexC <> tri1.vertexC Then
            beamorig(0) = tri2.vertexC.X : beamorig(1) = tri2.vertexC.Y
            If PowerRay.SCHNITTPKT_DREIECK(beamorig, beamdir, vert0, vert1, vert2) Then
                verticesInner.Add(tri2.vertexC)
                tri2.vertexC.selected = True
            End If
        End If

        ' -> Test auf Dreieck 2
        vert0(0) = tri2.vertexA.X
        vert0(1) = tri2.vertexA.Y
        vert1(0) = tri2.vertexB.X
        vert1(1) = tri2.vertexB.Y
        vert2(0) = tri2.vertexC.X
        vert2(1) = tri2.vertexC.Y
        If tri1.vertexA <> tri2.vertexA AndAlso tri1.vertexA <> tri2.vertexB AndAlso tri1.vertexA <> tri2.vertexC Then
            beamorig(0) = tri1.vertexA.X : beamorig(1) = tri1.vertexA.Y
            If PowerRay.SCHNITTPKT_DREIECK(beamorig, beamdir, vert0, vert1, vert2) Then
                verticesInner.Add(tri1.vertexA)
                tri1.vertexA.selected = True
            End If
        End If
        If tri1.vertexB <> tri2.vertexA AndAlso tri1.vertexB <> tri2.vertexB AndAlso tri1.vertexB <> tri2.vertexC Then
            beamorig(0) = tri1.vertexB.X : beamorig(1) = tri1.vertexB.Y
            If PowerRay.SCHNITTPKT_DREIECK(beamorig, beamdir, vert0, vert1, vert2) Then
                verticesInner.Add(tri1.vertexB)
                tri1.vertexB.selected = True
            End If
        End If
        If tri1.vertexC <> tri2.vertexA AndAlso tri1.vertexC <> tri2.vertexB AndAlso tri1.vertexC <> tri2.vertexC Then
            beamorig(0) = tri1.vertexC.X : beamorig(1) = tri1.vertexC.Y
            If PowerRay.SCHNITTPKT_DREIECK(beamorig, beamdir, vert0, vert1, vert2) Then
                verticesInner.Add(tri1.vertexC)
                tri1.vertexC.selected = True
            End If
        End If

        If verticesInner.Count > 0 OrElse verticesIntersections.Count > 0 Then

            ' Bestimme äußere Punkte:
            If Not verticesInner.Contains(tri1.vertexA) Then verticesOuter.Add(tri1.vertexA)
            If Not verticesInner.Contains(tri1.vertexB) Then verticesOuter.Add(tri1.vertexB)
            If Not verticesInner.Contains(tri1.vertexC) Then verticesOuter.Add(tri1.vertexC)

            If Not verticesInner.Contains(tri2.vertexA) Then verticesOuter.Add(tri2.vertexA)
            If Not verticesInner.Contains(tri2.vertexB) Then verticesOuter.Add(tri2.vertexB)
            If Not verticesInner.Contains(tri2.vertexC) Then verticesOuter.Add(tri2.vertexC)

            MainForm.Vertices.AddRange(verticesIntersections)
            verticesInner.AddRange(verticesIntersections)
            verticesComplete.AddRange(verticesInner)
            verticesComplete.AddRange(verticesOuter)

            Dim iTriangles As New List(Of MainForm.Triangle)
            For i1 As Integer = 0 To verticesComplete.Count - 1
                For i2 As Integer = i1 + 1 To verticesComplete.Count - 1
                    For i3 As Integer = i2 + 1 To verticesComplete.Count - 1
                        Dim ttri As New MainForm.Triangle(verticesComplete(i1), verticesComplete(i2), verticesComplete(i3), False)
                        If Not isTriangleInTriangle(ttri, tri1) Then Continue For
                        If Not isTriangleInTriangle(ttri, tri2) Then Continue For
                        Dim i4 As Integer = 0
                        While i4 < iTriangles.Count
                            Dim tri As MainForm.Triangle = iTriangles(i4)
                            If isPartlyTriangleInTriangle(ttri, tri) Then Continue For
                            i4 += 1
                        End While
                        If Not (ttri.vertexA = ttri.vertexB OrElse ttri.vertexA = ttri.vertexC OrElse ttri.vertexB = ttri.vertexC) Then
                            If tri1.triangleID > tri2.triangleID Then
                                MainForm.Triangles.Add(New MainForm.Triangle(verticesComplete(i3), verticesComplete(i1), verticesComplete(i2)) With {.myColour = tri1.myColour, .myColourNumber = tri1.myColourNumber})
                            Else
                                MainForm.Triangles.Add(New MainForm.Triangle(verticesComplete(i3), verticesComplete(i1), verticesComplete(i2)) With {.myColour = tri2.myColour, .myColourNumber = tri2.myColourNumber})
                            End If
                            verticesComplete(i3).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
                            verticesComplete(i1).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
                            verticesComplete(i2).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
                            MainForm.SelectedTriangles.Add(MainForm.LLast(MainForm.Triangles))
                            iTriangles.Add(MainForm.LLast(MainForm.Triangles))
                        Else
                            Continue For
                        End If
                    Next
                Next
            Next

            For i1 As Integer = 0 To verticesComplete.Count - 1
                For i2 As Integer = i1 + 1 To verticesComplete.Count - 1
                    For i3 As Integer = i2 + 1 To verticesComplete.Count - 1
                        Dim ttri As New MainForm.Triangle(verticesComplete(i1), verticesComplete(i2), verticesComplete(i3), False)
                        If Not isTriangleInTriangle(ttri, tri1) AndAlso Not isTriangleInTriangle(ttri, tri2) Then Continue For
                        Dim i4 As Integer = 0
                        While i4 < iTriangles.Count
                            Dim tri As MainForm.Triangle = iTriangles(i4)
                            If isPartlyTriangleInTriangle(ttri, tri) Then Continue For
                            i4 += 1
                        End While
                        If Not (ttri.vertexA = ttri.vertexB OrElse ttri.vertexA = ttri.vertexC OrElse ttri.vertexB = ttri.vertexC) Then
                            If isTriangleInTriangle(ttri, tri1) Then
                                MainForm.Triangles.Add(New MainForm.Triangle(verticesComplete(i3), verticesComplete(i1), verticesComplete(i2)) With {.myColour = tri1.myColour, .myColourNumber = tri1.myColourNumber})
                            Else
                                MainForm.Triangles.Add(New MainForm.Triangle(verticesComplete(i3), verticesComplete(i1), verticesComplete(i2)) With {.myColour = tri2.myColour, .myColourNumber = tri2.myColourNumber})
                            End If
                            verticesComplete(i3).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
                            verticesComplete(i1).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
                            verticesComplete(i2).linkedTriangles.Add(MainForm.LLast(MainForm.Triangles))
                            MainForm.SelectedTriangles.Add(MainForm.LLast(MainForm.Triangles))
                            iTriangles.Add(MainForm.LLast(MainForm.Triangles))
                        Else
                            Continue For
                        End If
                    Next
                Next
            Next
            If iTriangles.Count > 0 Then
                MainForm.SelectedTriangles.Remove(tri1)
                MainForm.SelectedTriangles.Remove(tri2)
                MainForm.removeTriangle(tri1)
                MainForm.removeTriangle(tri2)
                Return True
            Else
                Return False
            End If
        End If
    End Function

    Public Function CSG2ProjectionQuadIntersectionVertex(ByRef v1 As MainForm.Vertex, ByRef t1 As MainForm.Triangle, ByRef q1 As MainForm.ProjectionQuad) As MainForm.Vertex
        Dim v As MainForm.Vertex = Nothing
        If t1.vertexA.vertexID = v1.vertexID Then v = t1.vertexB
        If t1.vertexB.vertexID = v1.vertexID Then v = t1.vertexC
        If t1.vertexC.vertexID = v1.vertexID Then v = t1.vertexA
        Do
            For i = 0 To 2
                schnittpunkt = intersectionBetweenTwoLines(v1, v, New MainForm.Vertex(1000 * q1.inCoords(i, 0), 1000 * q1.inCoords(i, 1), False, False), New MainForm.Vertex(1000 * q1.inCoords(i + 1, 0), 1000 * q1.inCoords(i + 1, 1), False, False))
                If Not schnittpunkt Is Nothing Then Exit Do
            Next
            schnittpunkt = intersectionBetweenTwoLines(v1, v, New MainForm.Vertex(1000 * q1.inCoords(3, 0), 1000 * q1.inCoords(3, 1), False, False), New MainForm.Vertex(1000 * q1.inCoords(0, 0), 1000 * q1.inCoords(0, 1), False, False))
            If Not schnittpunkt Is Nothing Then Exit Do
            Return Nothing
        Loop
        Return schnittpunkt
    End Function

    Public Function CSG2TrianglesIntersectionsOnly(ByRef tri1 As MainForm.Triangle, ByRef tri2 As MainForm.Triangle, Optional ByVal output_vertices As Boolean = True) As Boolean

        Dim verticesIntersections As New List(Of MainForm.Vertex)

        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexA, tri1.vertexB, tri2.vertexA, tri2.vertexB)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False, output_vertices))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexA, tri1.vertexB, tri2.vertexB, tri2.vertexC)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False, output_vertices))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexA, tri1.vertexB, tri2.vertexC, tri2.vertexA)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False, output_vertices))

        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexB, tri1.vertexC, tri2.vertexA, tri2.vertexB)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False, output_vertices))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexB, tri1.vertexC, tri2.vertexB, tri2.vertexC)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False, output_vertices))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexB, tri1.vertexC, tri2.vertexC, tri2.vertexA)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False, output_vertices))

        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexC, tri1.vertexA, tri2.vertexA, tri2.vertexB)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False, output_vertices))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexC, tri1.vertexA, tri2.vertexB, tri2.vertexC)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False, output_vertices))
        schnittpunkt = intersectionBetweenTwoLines(tri1.vertexC, tri1.vertexA, tri2.vertexC, tri2.vertexA)
        If Not schnittpunkt Is Nothing Then verticesIntersections.Add(New MainForm.Vertex(schnittpunkt.X, schnittpunkt.Y, False, output_vertices))

        If output_vertices Then
            MainForm.Vertices.AddRange(verticesIntersections)
        Else
            Dim start As Integer = 0
newRemove:
            For i As Integer = start To verticesIntersections.Count - 1
                Dim v As MainForm.Vertex = verticesIntersections(i)
                If tri1.vertexA.X = v.X AndAlso tri1.vertexA.Y = v.Y Then verticesIntersections.RemoveAt(i) : start = i : GoTo newRemove
                If tri1.vertexB.X = v.X AndAlso tri1.vertexB.Y = v.Y Then verticesIntersections.RemoveAt(i) : start = i : GoTo newRemove
                If tri1.vertexC.X = v.X AndAlso tri1.vertexC.Y = v.Y Then verticesIntersections.RemoveAt(i) : start = i : GoTo newRemove

                If tri2.vertexA.X = v.X AndAlso tri2.vertexA.Y = v.Y Then verticesIntersections.RemoveAt(i) : start = i : GoTo newRemove
                If tri2.vertexB.X = v.X AndAlso tri2.vertexB.Y = v.Y Then verticesIntersections.RemoveAt(i) : start = i : GoTo newRemove
                If tri2.vertexC.X = v.X AndAlso tri2.vertexC.Y = v.Y Then verticesIntersections.RemoveAt(i) : start = i : GoTo newRemove
            Next
        End If


        Return verticesIntersections.Count > 0

    End Function

    Private Function isTriangleInTriangle(ByVal tri1 As MainForm.Triangle, ByVal tri2 As MainForm.Triangle)
        Dim tri2c(,) As Single = {{tri2.vertexA.X, tri2.vertexA.Y}, {tri2.vertexB.X, tri2.vertexB.Y}, {tri2.vertexC.X, tri2.vertexC.Y}}
        Dim beamdir() As Decimal = {0, 0, -1}
        Dim center() As Single = {(tri1.vertexA.X + tri1.vertexB.X + tri1.vertexC.X) / 3, (tri1.vertexA.Y + tri1.vertexB.Y + tri1.vertexC.Y) / 3}
        Dim dA As Single = Math.Sqrt((tri1.vertexA.X - center(0)) ^ 2 + (tri1.vertexA.Y - center(1)) ^ 2)
        Dim dB As Single = Math.Sqrt((tri1.vertexB.X - center(0)) ^ 2 + (tri1.vertexB.Y - center(1)) ^ 2)
        Dim dC As Single = Math.Sqrt((tri1.vertexC.X - center(0)) ^ 2 + (tri1.vertexC.Y - center(1)) ^ 2)
        If dA = 0 OrElse dB = 0 OrElse dC = 0 Then Return False
        Dim beamorig1() As Decimal = {tri1.vertexA.X + 0.5 * (center(0) - tri1.vertexA.X) / dA, tri1.vertexA.Y + 0.5 * (center(1) - tri1.vertexA.Y) / dA, 0}
        Dim beamorig2() As Decimal = {tri1.vertexB.X + 0.5 * (center(0) - tri1.vertexB.X) / dB, tri1.vertexB.Y + 0.5 * (center(1) - tri1.vertexB.Y) / dB, 0}
        Dim beamorig3() As Decimal = {tri1.vertexC.X + 0.5 * (center(0) - tri1.vertexC.X) / dC, tri1.vertexC.Y + 0.5 * (center(1) - tri1.vertexC.Y) / dC, 0}
        Dim vert00() As Decimal = {tri2c(0, 0), tri2c(0, 1), 0}
        Dim vert01() As Decimal = {tri2c(1, 0), tri2c(1, 1), 0}
        Dim vert02() As Decimal = {tri2c(2, 0), tri2c(2, 1), 0}
        Return PowerRay.SCHNITTPKT_DREIECK(beamorig1, beamdir, vert00, vert01, vert02) AndAlso _
               PowerRay.SCHNITTPKT_DREIECK(beamorig2, beamdir, vert00, vert01, vert02) AndAlso _
               PowerRay.SCHNITTPKT_DREIECK(beamorig3, beamdir, vert00, vert01, vert02)
    End Function

    Private Function isPartlyTriangleInTriangle(ByVal tri1 As MainForm.Triangle, ByVal tri2 As MainForm.Triangle)
        Dim tri2c(,) As Single = {{tri2.vertexA.X, tri2.vertexA.Y}, {tri2.vertexB.X, tri2.vertexB.Y}, {tri2.vertexC.X, tri2.vertexC.Y}}
        Dim beamdir() As Decimal = {0, 0, -1}
        Dim center() As Single = {(tri1.vertexA.X + tri1.vertexB.X + tri1.vertexC.X) / 3, (tri1.vertexA.Y + tri1.vertexB.Y + tri1.vertexC.Y) / 3}
        Dim dA As Single = Math.Sqrt((tri1.vertexA.X - center(0)) ^ 2 + (tri1.vertexA.Y - center(1)) ^ 2)
        Dim dB As Single = Math.Sqrt((tri1.vertexB.X - center(0)) ^ 2 + (tri1.vertexB.Y - center(1)) ^ 2)
        Dim dC As Single = Math.Sqrt((tri1.vertexC.X - center(0)) ^ 2 + (tri1.vertexC.Y - center(1)) ^ 2)
        If dA = 0 OrElse dB = 0 OrElse dC = 0 Then Return True
        Dim beamorig1() As Decimal = {tri1.vertexA.X + 0.5 * (center(0) - tri1.vertexA.X) / dA, tri1.vertexA.Y + 0.5 * (center(1) - tri1.vertexA.Y) / dA, 0}
        Dim beamorig2() As Decimal = {tri1.vertexB.X + 0.5 * (center(0) - tri1.vertexB.X) / dB, tri1.vertexB.Y + 0.5 * (center(1) - tri1.vertexB.Y) / dB, 0}
        Dim beamorig3() As Decimal = {tri1.vertexC.X + 0.5 * (center(0) - tri1.vertexC.X) / dC, tri1.vertexC.Y + 0.5 * (center(1) - tri1.vertexC.Y) / dC, 0}
        Dim vert00() As Decimal = {tri2c(0, 0), tri2c(0, 1), 0}
        Dim vert01() As Decimal = {tri2c(1, 0), tri2c(1, 1), 0}
        Dim vert02() As Decimal = {tri2c(2, 0), tri2c(2, 1), 0}
        Return PowerRay.SCHNITTPKT_DREIECK(beamorig1, beamdir, vert00, vert01, vert02) OrElse _
               PowerRay.SCHNITTPKT_DREIECK(beamorig2, beamdir, vert00, vert01, vert02) OrElse _
               PowerRay.SCHNITTPKT_DREIECK(beamorig3, beamdir, vert00, vert01, vert02)
    End Function

End Module
