﻿' MIT - Licence
'
' Copyright (c) 2010 - 2011 Nils Schmidt
' This program uses Rectifier.exe by permission of the author and copyright holder Philippe E. Hurbain - (C) 2009

' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
' to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
' and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

' The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
' PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
' FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
' ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Option Strict Off
Public Class ColourForm

    Private Sub ColourForm_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If MainForm.cstep = 1 Then
            If e.KeyCode = Keys.NumPad1 Then MainForm.cnumber += 1
            If e.KeyCode = Keys.NumPad2 Then MainForm.cnumber += 2
            If e.KeyCode = Keys.NumPad3 Then MainForm.cnumber += 3
            If e.KeyCode = Keys.NumPad4 Then MainForm.cnumber += 4
            If e.KeyCode = Keys.NumPad5 Then MainForm.cnumber += 5
            If e.KeyCode = Keys.NumPad6 Then MainForm.cnumber += 6
            If e.KeyCode = Keys.NumPad7 Then MainForm.cnumber += 7
            If e.KeyCode = Keys.NumPad8 Then MainForm.cnumber += 8
            If e.KeyCode = Keys.NumPad9 Then MainForm.cnumber += 9
            MainForm.addHistoryI(MainForm.withDataFrom.Triangles + MainForm.withDataFrom.SelectedTriangles + MainForm.withDataFrom.Primitives)
            If MainForm.colourHMap.ContainsKey(MainForm.cnumber) Then
                MainForm.setColour(MainForm.colourHMap(MainForm.cnumber), MainForm.cnumber)
            Else
                MainForm.setColour(MainForm.colourHMap(16), MainForm.cnumber)
            End If
            MainForm.addHistoryII(MainForm.withDataFrom.Triangles + MainForm.withDataFrom.SelectedTriangles + MainForm.withDataFrom.Primitives)
            MainForm.cstep = 100 : MainForm.cnumber = 0
        Else
            If e.KeyCode = Keys.Escape Then MainForm.cstep = 100 : MainForm.cnumber = 0
            If e.KeyCode = Keys.NumPad0 Then MainForm.cstep /= 10
            If e.KeyCode = Keys.NumPad1 Then MainForm.cnumber += 1 * MainForm.cstep : MainForm.cstep /= 10
            If e.KeyCode = Keys.NumPad2 Then MainForm.cnumber += 2 * MainForm.cstep : MainForm.cstep /= 10
            If e.KeyCode = Keys.NumPad3 Then MainForm.cnumber += 3 * MainForm.cstep : MainForm.cstep /= 10
            If e.KeyCode = Keys.NumPad4 Then MainForm.cnumber += 4 * MainForm.cstep : MainForm.cstep /= 10
            If e.KeyCode = Keys.NumPad5 Then MainForm.cnumber += 5 * MainForm.cstep : MainForm.cstep /= 10
            If e.KeyCode = Keys.NumPad6 Then MainForm.cnumber += 6 * MainForm.cstep : MainForm.cstep /= 10
            If e.KeyCode = Keys.NumPad7 Then MainForm.cnumber += 7 * MainForm.cstep : MainForm.cstep /= 10
            If e.KeyCode = Keys.NumPad8 Then MainForm.cnumber += 8 * MainForm.cstep : MainForm.cstep /= 10
            If e.KeyCode = Keys.NumPad9 Then MainForm.cnumber += 9 * MainForm.cstep : MainForm.cstep /= 10
        End If
    End Sub

    Private Sub ColourForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.TopMost = True
        ' Buttons anlegen
        For i As Integer = 0 To MainForm.maxColourNumber
            If MainForm.colourHMap.ContainsKey(i) Then
                Dim btn As New Button
                btn.Height = 25
                btn.Width = 25
                ToolTip1.SetToolTip(btn, "Colour " & i & ": " & MainForm.colourHMapName(i))
                btn.Name = "btn" & i

                btn.BackColor = MainForm.colourHMap(i)
                btn.Tag = i


                btn.FlatStyle = FlatStyle.Flat
                Me.Controls("Colours").Controls.Add(btn)
                AddHandler btn.Click, AddressOf btn_click

            End If
        Next
        Me.Label1.Text = "Tip: Use the numpad to type in colour numbers directly." & vbCrLf & "E.g. ""015"" for white. Press " & KeyToSet.keyToString(New KeyEventArgs(MainForm.myKeys.Abort)) & " to cancel your input."
    End Sub

    Private Sub btn_click(ByVal sender As Object, ByVal e As EventArgs)
        MainForm.addHistoryI(MainForm.withDataFrom.Triangles + MainForm.withDataFrom.SelectedTriangles + MainForm.withDataFrom.Primitives)
        MainForm.setColour(MainForm.colourHMap(CType(sender.Tag, Short)), CType(sender.Tag, Short))
        MainForm.addHistoryII(MainForm.withDataFrom.Triangles + MainForm.withDataFrom.SelectedTriangles + MainForm.withDataFrom.Primitives)
    End Sub

    Private Sub Colours_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Colours.MouseMove
        If Not Me.Focused Then
            Dim sbv As Decimal
            sbv = Colours.VerticalScroll.Value
            Me.Activate()
            Colours.VerticalScroll.Value = sbv
        End If
    End Sub



    Private Sub Colours_Scroll(ByVal sender As Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles Colours.Scroll
        If Not Me.Focused Then
            Dim sbv As Decimal
            sbv = Colours.VerticalScroll.Value
            Me.Activate()
            Colours.VerticalScroll.Value = sbv
        End If
    End Sub

    Private Sub BrnDirectColour_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BrnDirectColour.Click
        MainForm.addHistoryI(MainForm.withDataFrom.Triangles + MainForm.withDataFrom.SelectedTriangles + MainForm.withDataFrom.Primitives)
        MainForm.setColour(Color.FromArgb(255, Fix(NR.Value), Fix(NG.Value), Fix(NB.Value)), -1)
        MainForm.addHistoryII(MainForm.withDataFrom.Triangles + MainForm.withDataFrom.SelectedTriangles + MainForm.withDataFrom.Primitives)
    End Sub
End Class