﻿Option Strict Off
Module KeyToSet
    Public keyToSet As System.Windows.Forms.KeyEventArgs
    Public Function keyToString(ByVal key As System.Windows.Forms.KeyEventArgs) As String
        Dim keyString As String = ""
        If key.Control Then
            keyString += "Ctrl+"
        End If
        If key.Shift Then
            keyString += "Shift+"
        End If
        If key.Alt Then
            keyString += "Alt+"
        End If
        keyString += key.KeyCode.ToString
        keyString = Replace(keyString, "D0", "0")
        keyString = Replace(keyString, "D1", "1")
        keyString = Replace(keyString, "D2", "2")
        keyString = Replace(keyString, "D3", "3")
        keyString = Replace(keyString, "D4", "4")
        keyString = Replace(keyString, "D5", "5")
        keyString = Replace(keyString, "D6", "6")
        keyString = Replace(keyString, "D7", "7")
        keyString = Replace(keyString, "D8", "8")
        keyString = Replace(keyString, "D9", "9")
        keyString = Replace(keyString, "+ControlKey", "")
        keyString = Replace(keyString, "+ShiftKey", "")
        keyString = Replace(keyString, "+Menu", "")
        keyString = Replace(keyString, "Delete", "Del")
        keyString = Replace(keyString, "Escape", "Esc")
        Return keyString
    End Function

    Public Sub setKey(ByRef target As Object, ByVal keyindex As Integer)
        Dim keystring As String = keyToString(New System.Windows.Forms.KeyEventArgs(keyindex))
        If TypeOf target Is ToolStripMenuItem Then
            Select Case CType(target, ToolStripMenuItem).Name
                Case "ImageToolStripMenuItem"
                    MainForm.GBImage.Text = "Background-Image [" & keystring & "]"
                Case "SnappingToolStripMenuItem"
                    MainForm.GBSnap.Text = "View-Preferences [" & keystring & "]"
                Case "VerticesModeToolStripMenuItem"
                    MainForm.CMSVertex.ShortcutKeyDisplayString = keystring
                Case "TriangleModeToolStripMenuItem"
                    MainForm.CMSTriangle.ShortcutKeyDisplayString = keystring
                Case "PrimitiveModeToolStripMenuItem"
                    MainForm.CMSPrimitive.ShortcutKeyDisplayString = keystring
            End Select
            CType(target, ToolStripMenuItem).ShortcutKeys = keyindex : CType(target, ToolStripMenuItem).ShortcutKeyDisplayString = keystring
        ElseIf TypeOf target Is ToolStripButton Then
            CType(target, ToolStripButton).ToolTipText = target.Text & " [" & keystring & "]"
            Select Case CType(target, ToolStripButton).Name
                Case "BtnSelect"
                    MainForm.CMSSelect.ShortcutKeyDisplayString = keystring
                    MainForm.myKeys.ModeSelect = keyindex
                Case "BtnMove"
                    MainForm.CMSMove.ShortcutKeyDisplayString = keystring
                    MainForm.myKeys.ModeMove = keyindex
                Case "BtnRotate"
                    MainForm.CMSRotate.ShortcutKeyDisplayString = keystring
                    MainForm.myKeys.ModeRotate = keyindex
                Case "BtnScale"
                    MainForm.CMSScale.ShortcutKeyDisplayString = keystring
                    MainForm.myKeys.ModeScale = keyindex
                Case "BtnAddVertex"
                    MainForm.CMSAddVertex.ShortcutKeyDisplayString = keystring
                    MainForm.myKeys.AddVertex = keyindex
                Case "BtnAddTriangle"
                    MainForm.CMSAddTriangle.ShortcutKeyDisplayString = keystring
                    MainForm.myKeys.AddTriangle = keyindex
                Case "BtnPreview"
                    MainForm.myKeys.Preview = keyindex
                Case "BtnColours"
                    MainForm.myKeys.ShowColours = keyindex
                Case "BtnPipette"
                    MainForm.myKeys.Pipette = keyindex
            End Select
        ElseIf TypeOf target Is Button Then
            CType(target, Button).Text = Mid(target.Text, 1, target.Text.IndexOf("[") - 1) & " [" & keystring & "]"
            Select Case CType(target, Button).Name
                Case "BtnAbort"
                    MainForm.myKeys.Abort = keyindex
                    ColourForm.Label1.Text = "Tip: Use the numpad to type in colour numbers directly." & vbCrLf & "E.g. ""015"" for white. Press " & keyToString(New KeyEventArgs(MainForm.myKeys.Abort)) & " to cancel your input."
                    ColourForm.Refresh()
                Case "BtnZoom"
                    MainForm.myKeys.Zoom = keyindex
                Case "BtnTranslate"
                    MainForm.myKeys.Translate = keyindex
            End Select
        End If
    End Sub
End Module
