﻿Option Strict Off
Imports System.Windows.Forms

Public Class OptionsDialog
    Private keyDict As New Dictionary(Of String, Integer)

    Private dummyToolStripMenuItem As New ToolStripMenuItem
    Private dummyKeyEventArgs As System.Windows.Forms.KeyEventArgs

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        saveKeys()
        saveSettings()
        saveColours()
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub OptionsDialog_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        loadKeys()
        loadSettings()
        loadColours()
    End Sub

    Private Sub loadColours()
        LColours.Items.Clear()
        LTags.Items.Clear()
        'background = Color.FromArgb(0, 0, 0)
        'linePen = New Pen(Color.FromArgb(234, 244, 234), 1)
        'inverseLinePen = New Pen(Color.FromArgb(12, 12, 12), 1)
        'selectedLinePen = New Pen(Color.FromArgb(245, 12, 12), 1)
        'selectedLineInVertexModePen = New Pen(Color.FromArgb(245, 180, 180), 1)
        'vertexBrush = New SolidBrush(Color.FromArgb(245, 245, 12))
        'selectedVertexBrush = New SolidBrush(Color.FromArgb(245, 12, 12))
        'originPen = New Pen(Color.FromArgb(140, 215, 140), 1)
        'gridPen = New Pen(Color.FromArgb(0, 60, 0), 1)
        'grid10Pen = New Pen(Color.FromArgb(60, 60, 105), 1)
        'selectionRectPen = New Pen(Color.FromArgb(245, 245, 220), 1)
        'selectionCrossBrush = New SolidBrush(Color.FromArgb(120, 0, 0))
        addColour("Background", MainForm.myColours.background)
        PBack.BackColor = MainForm.myColours.background
        addColour("Line", MainForm.myColours.linePen)
        addColour("Inverse Line", MainForm.myColours.inverseLinePen)
        addColour("Selected Line", MainForm.myColours.selectedLinePen)
        addColour("Selected Line in Vertex Mode", MainForm.myColours.selectedLineInVertexModePen)
        addColour("Vertex", MainForm.myColours.vertexBrush)
        addColour("Selected Vertex", MainForm.myColours.selectedVertexBrush)
        addColour("Origin", MainForm.myColours.originPen)
        addColour("Grid", MainForm.myColours.gridPen)
        addColour("Grid-10", MainForm.myColours.grid10Pen)
        addColour("Selection Rectangle", MainForm.myColours.selectionRectPen)
        addColour("Selection Cross in Primitive Mode", MainForm.myColours.selectionCrossBrush)
    End Sub

    Private Sub saveColours()
        MainForm.myColours.background = LTags.Items(0)
        Try
            MainForm.BackColor = CType(LTags.Items(0), Color)
            MainForm.Opacity = 1D
        Catch
            MainForm.BackColor = Color.FromArgb(CType(LTags.Items(0), Color).R, CType(LTags.Items(0), Color).G, CType(LTags.Items(0), Color).B)
            MainForm.Opacity = CType(LTags.Items(0), Color).A / 255
        End Try
        MainForm.myColours.linePen = LTags.Items(1)
        MainForm.myColours.inverseLinePen = LTags.Items(2)
        MainForm.myColours.selectedLinePen = LTags.Items(3)
        MainForm.myColours.selectedLineInVertexModePen = LTags.Items(4)
        MainForm.myColours.vertexBrush = LTags.Items(5)
        MainForm.myColours.selectedVertexBrush = LTags.Items(6)
        MainForm.myColours.originPen = LTags.Items(7)
        MainForm.myColours.gridPen = LTags.Items(8)
        MainForm.myColours.grid10Pen = LTags.Items(9)
        MainForm.myColours.selectionRectPen = LTags.Items(10)
        MainForm.myColours.selectionCrossBrush = LTags.Items(11)
    End Sub

    Private Sub loadSettings()
        CBLicense.Text = MainForm.mySettings.defaultLicense
        TBRealName.Text = MainForm.mySettings.defaultName
        TBUserName.Text = MainForm.mySettings.defaultUser
        NUDMaxUndo.Value = MainForm.mySettings.max_undo
        CBPerformaceMode.Checked = MainForm.mySettings.performanceMode
        CBViewImage.Checked = MainForm.mySettings.showImageViewAtStartup
        CBViewPreferences.Checked = MainForm.mySettings.showPreferencesViewAtStartup
        CBFullscreen.Checked = MainForm.mySettings.startWithFullscreen
        CBAlternativeZoomAndTrans.Checked = MainForm.mySettings.useAlternativeKeys
    End Sub

    Private Sub loadKeys()
        keyDict.Clear()
        keyDict.Add("NumPad0", -1)
        keyDict.Add("NumPad1", -1)
        keyDict.Add("NumPad2", -1)
        keyDict.Add("NumPad3", -1)
        keyDict.Add("NumPad4", -1)
        keyDict.Add("NumPad5", -1)
        keyDict.Add("NumPad6", -1)
        keyDict.Add("NumPad7", -1)
        keyDict.Add("NumPad8", -1)
        keyDict.Add("NumPad9", -1)
        keyDict.Add("Del", -1)
        keyDict.Add("Ctrl+X", -1)
        keyDict.Add("Ctrl+C", -1)
        keyDict.Add("Ctrl+V", -1)
        keyDict.Add("Ctrl+Z", -1)
        keyDict.Add("Ctrl+Y", -1)
        keyDict.Add("Ctrl+Q", -1)
        keyDict.Add("Ctrl+Alt", -2)
        keyDict.Add("Ctrl+Shift", -2)
        keyDict.Add("Shift+Alt", -2)
        keyDict.Add("Ctrl+Shift+Alt", -2)
        Shortkeys.Rows.Clear()
        If CBAlternativeZoomAndTrans.Checked Then
            If My.Computer.Mouse.ButtonsSwapped Then
                Shortkeys.Rows.Add("Show context menue", "Left mouse button", "---", -1)
            Else
                Shortkeys.Rows.Add("Show context menue", "Right mouse button", "---", -1)
            End If
        Else
            If My.Computer.Mouse.ButtonsSwapped Then
                Shortkeys.Rows.Add("Show context menue / translate view", "Left mouse button", "---", -1)
            Else
                Shortkeys.Rows.Add("Show context menue / translate view", "Right mouse button", "---", -1)
            End If
        End If
        Shortkeys.Rows(Shortkeys.Rows.Count - 1).Tag = 0
        addKey("Create a new pattern", MainForm.NewPatternToolStripMenuItem)
        addKey("Load a existing pattern", MainForm.LoadPatternToolStripMenuItem)
        addKey("Save pattern", MainForm.SaveToolStripMenuItem)
        addKey("Activate Selection-Mode", MainForm.BtnSelect)
        addKey("Activate Move-Mode", MainForm.BtnMove)
        addKey("Activate Rotation-Mode", MainForm.BtnRotate)
        addKey("Activate Scale-Mode", MainForm.BtnScale)
        addKey("Activate 'Add Vertex'", MainForm.BtnAddVertex)
        addKey("Activate 'Add Triangle'", MainForm.BtnAddTriangle)
        addKey("Editmode: Vertices", MainForm.VerticesModeToolStripMenuItem)
        addKey("Editmode: Triangles", MainForm.TriangleModeToolStripMenuItem)
        addKey("Editmode: Primitives", MainForm.PrimitiveModeToolStripMenuItem)

        addKey("Show Image-Preferences", MainForm.ImageToolStripMenuItem)
        addKey("Show View-Preferences", MainForm.SnappingToolStripMenuItem)

        addKey("Show Preview", MainForm.BtnPreview)
        addKey("Show Colours", MainForm.BtnColours)
        addKey("Take Colour from Selection", MainForm.BtnPipette)
        addKey("Abort / OK - Button", MainForm.BtnAbort)

        addKey("Alternative: Zoom", MainForm.BtnZoom)
        addKey("Alternative: View Translation", MainForm.BtnTranslate)
        addKey("Reset View", MainForm.ResetViewToolStripMenuItem)
        addKey("Select All", MainForm.SelectAllToolStripMenuItem)
        addKey("Select Same Colour", MainForm.SelectSameColourToolStripMenuItem)
        addKey("Select Connected", MainForm.SelectConnectedToolStripMenuItem)
        addKey("Select Touching", MainForm.SelectTouchingToolStripMenuItem)
        addKey("..with Same Colour", MainForm.WithColourToolStripMenuItem)
        addKey("Merge to average", MainForm.ToAverageToolStripMenuItem)
        addKey("Merge to last selected", MainForm.ToLastSelectedToolStripMenuItem)
    End Sub

    Private Sub saveSettings()
        MainForm.mySettings.defaultLicense = CBLicense.Text
        MainForm.mySettings.defaultName = TBRealName.Text
        MainForm.mySettings.defaultUser = TBUserName.Text
        MainForm.mySettings.max_undo = Fix(NUDMaxUndo.Value)
        MainForm.mySettings.performanceMode = CBPerformaceMode.Checked
        MainForm.mySettings.showImageViewAtStartup = CBViewImage.Checked
        MainForm.mySettings.showPreferencesViewAtStartup = CBViewPreferences.Checked
        MainForm.mySettings.startWithFullscreen = CBFullscreen.Checked
        MainForm.mySettings.useAlternativeKeys = CBAlternativeZoomAndTrans.Checked
        If MainForm.PerformanceEnabledToolStripMenuItem.Checked <> CBPerformaceMode.Checked Then MainForm.PerformanceEnabledToolStripMenuItem.PerformClick()
    End Sub

    Private Sub saveKeys()
        For i As Integer = 0 To Shortkeys.Rows.Count - 1
            If TypeOf Shortkeys.Rows(i).Tag Is ToolStripMenuItem Then
                Select Case CType(Shortkeys.Rows(i).Tag, ToolStripMenuItem).Name
                    Case "ImageToolStripMenuItem"
                        MainForm.GBImage.Text = "Background-Image [" & Shortkeys.Rows(i).Cells(1).Value & "]"
                    Case "SnappingToolStripMenuItem"
                        MainForm.GBSnap.Text = "View-Preferences [" & Shortkeys.Rows(i).Cells(1).Value & "]"
                    Case "VerticesModeToolStripMenuItem"
                        MainForm.CMSVertex.ShortcutKeyDisplayString = Shortkeys.Rows(i).Cells(1).Value
                    Case "TriangleModeToolStripMenuItem"
                        MainForm.CMSTriangle.ShortcutKeyDisplayString = Shortkeys.Rows(i).Cells(1).Value
                    Case "PrimitiveModeToolStripMenuItem"
                        MainForm.CMSPrimitive.ShortcutKeyDisplayString = Shortkeys.Rows(i).Cells(1).Value
                End Select
                CType(Shortkeys.Rows(i).Tag, ToolStripMenuItem).ShortcutKeys = CType(Shortkeys.Rows(i).Cells(3).Value, Integer) : CType(Shortkeys.Rows(i).Tag, ToolStripMenuItem).ShortcutKeyDisplayString = Shortkeys.Rows(i).Cells(1).Value
            ElseIf TypeOf Shortkeys.Rows(i).Tag Is ToolStripButton Then
                CType(Shortkeys.Rows(i).Tag, ToolStripButton).ToolTipText = Shortkeys.Rows(i).Tag.Text & " [" & Shortkeys.Rows(i).Cells(1).Value & "]"
                Select Case CType(Shortkeys.Rows(i).Tag, ToolStripButton).Name
                    Case "BtnSelect"
                        MainForm.CMSSelect.ShortcutKeyDisplayString = Shortkeys.Rows(i).Cells(1).Value
                        MainForm.myKeys.ModeSelect = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                    Case "BtnMove"
                        MainForm.CMSMove.ShortcutKeyDisplayString = Shortkeys.Rows(i).Cells(1).Value
                        MainForm.myKeys.ModeMove = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                    Case "BtnRotate"
                        MainForm.CMSRotate.ShortcutKeyDisplayString = Shortkeys.Rows(i).Cells(1).Value
                        MainForm.myKeys.ModeRotate = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                    Case "BtnScale"
                        MainForm.CMSScale.ShortcutKeyDisplayString = Shortkeys.Rows(i).Cells(1).Value
                        MainForm.myKeys.ModeScale = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                    Case "BtnAddVertex"
                        MainForm.CMSAddVertex.ShortcutKeyDisplayString = Shortkeys.Rows(i).Cells(1).Value
                        MainForm.myKeys.AddVertex = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                    Case "BtnAddTriangle"
                        MainForm.CMSAddTriangle.ShortcutKeyDisplayString = Shortkeys.Rows(i).Cells(1).Value
                        MainForm.myKeys.AddTriangle = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                    Case "BtnPreview"
                        MainForm.myKeys.Preview = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                    Case "BtnColours"
                        MainForm.myKeys.ShowColours = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                    Case "BtnPipette"
                        MainForm.myKeys.Pipette = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                End Select
            ElseIf TypeOf Shortkeys.Rows(i).Tag Is Button Then
                CType(Shortkeys.Rows(i).Tag, Button).Text = Mid(Shortkeys.Rows(i).Tag.Text, 1, Shortkeys.Rows(i).Tag.Text.IndexOf("[") - 1) & " [" & Shortkeys.Rows(i).Cells(1).Value & "]"
                Select Case CType(Shortkeys.Rows(i).Tag, Button).Name
                    Case "BtnAbort"
                        MainForm.myKeys.Abort = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                        ColourForm.Label1.Text = "Tip: Use the numpad to type in colour numbers directly." & vbCrLf & "E.g. ""015"" for white. Press " & KeyToSet.keyToString(New KeyEventArgs(MainForm.myKeys.Abort)) & " to cancel your input."
                        ColourForm.Refresh()
                    Case "BtnZoom"
                        MainForm.myKeys.Zoom = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                    Case "BtnTranslate"
                        MainForm.myKeys.Translate = CType(Shortkeys.Rows(i).Cells(3).Value, Integer)
                End Select
            End If
        Next
    End Sub

    Private Sub addKey(ByVal description As String, ByRef target As Object)
        If TypeOf target Is ToolStripMenuItem Then
            Shortkeys.Rows.Add(description, CType(target, ToolStripMenuItem).ShortcutKeyDisplayString, "Set Key", CType(target, ToolStripMenuItem).ShortcutKeys)
            keyDict.Add(CType(target, ToolStripMenuItem).ShortcutKeyDisplayString, Shortkeys.Rows.Count - 1)
            Shortkeys.Rows(Shortkeys.Rows.Count - 1).Tag = target
        ElseIf TypeOf target Is ToolStripButton Then
            Dim keyindex As Integer
            Dim keystring As String = Replace(Replace(target.ToolTipText, target.Text & " [", ""), "]", "")
            Select Case CType(target, ToolStripButton).Name
                Case "BtnSelect"
                    keyindex = MainForm.myKeys.ModeSelect
                Case "BtnMove"
                    keyindex = MainForm.myKeys.ModeMove
                Case "BtnRotate"
                    keyindex = MainForm.myKeys.ModeRotate
                Case "BtnScale"
                    keyindex = MainForm.myKeys.ModeScale
                Case "BtnAddVertex"
                    keyindex = MainForm.myKeys.AddVertex
                Case "BtnAddTriangle"
                    keyindex = MainForm.myKeys.AddTriangle
                Case "BtnPreview"
                    keyindex = MainForm.myKeys.Preview
                Case "BtnColours"
                    keyindex = MainForm.myKeys.ShowColours
                Case "BtnPipette"
                    keyindex = MainForm.myKeys.Pipette
            End Select
            Shortkeys.Rows.Add(description, keystring, "Set Key", keyindex)
            keyDict.Add(keystring, Shortkeys.Rows.Count - 1)
            Shortkeys.Rows(Shortkeys.Rows.Count - 1).Tag = target
        ElseIf TypeOf target Is Button Then
            Dim keyindex As Integer
            Dim keystring As String = Replace(Replace(Mid(target.Text, target.Text.lastIndexOf("[") + 1), "[", ""), "]", "")
            Select Case CType(target, Button).Name
                Case "BtnAbort"
                    keyindex = MainForm.myKeys.Abort
                Case "BtnZoom"
                    keyindex = MainForm.myKeys.Zoom
                Case "BtnTranslate"
                    keyindex = MainForm.myKeys.Translate
            End Select
            Shortkeys.Rows.Add(description, keystring, "Set Key", keyindex)
            keyDict.Add(keystring, Shortkeys.Rows.Count - 1)
            Shortkeys.Rows(Shortkeys.Rows.Count - 1).Tag = target
        End If
    End Sub

    Private Sub addColour(ByVal description As String, ByRef reference As Object)
        LColours.Items.Add(description)
        LTags.Items.Add(reference)
    End Sub

    Private Sub Shortkeys_CellContentClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles Shortkeys.CellContentClick
        If e.ColumnIndex = 2 AndAlso Shortkeys.Rows(e.RowIndex).Cells(2).Value = "Set Key" Then
newTry:
            If SetKeyDialog.ShowDialog = Windows.Forms.DialogResult.OK Then
                Dim keyString As String
                keyString = keyToString(KeyToSet.keyToSet)
                If keyDict.ContainsKey(keyString) AndAlso (keyDict(keyString) <> e.RowIndex OrElse keyDict(keyString) < 0) Then
                    If keyDict(keyString) = -2 Then
                        If MsgBox("This key combination is invalid." & vbCrLf & "Please try another combination.", MsgBoxStyle.RetryCancel + MsgBoxStyle.MsgBoxSetForeground + MsgBoxStyle.Exclamation + MsgBoxStyle.DefaultButton2, "Information:") = MsgBoxResult.Retry Then GoTo newTry
                    Else
                        If MsgBox("This key combination is already in use." & vbCrLf & "Please try another combination.", MsgBoxStyle.RetryCancel + MsgBoxStyle.MsgBoxSetForeground + MsgBoxStyle.Information + MsgBoxStyle.DefaultButton2, "Information:") = MsgBoxResult.Retry Then GoTo newTry
                    End If
                Else
                    If TypeOf Shortkeys.Rows(e.RowIndex).Tag Is ToolStripMenuItem Then
                        Try
                            dummyToolStripMenuItem.ShortcutKeys = KeyToSet.keyToSet.KeyData
                        Catch ex As Exception
                            If MsgBox("This key combination is invalid." & vbCrLf & "Please try another combination.", MsgBoxStyle.RetryCancel + MsgBoxStyle.MsgBoxSetForeground + MsgBoxStyle.Exclamation + MsgBoxStyle.DefaultButton2, "Information:") = MsgBoxResult.Retry Then GoTo newTry
                            Exit Sub
                        End Try
                    End If
                    keyDict.Remove(Shortkeys.Rows(e.RowIndex).Cells(1).Value & "")
                    keyDict.Add(keyString, e.RowIndex)
                    Shortkeys.Rows(e.RowIndex).Cells(1).Value = keyString
                    If keyString <> "Ctrl" AndAlso keyString <> "Alt" AndAlso keyString <> "Shift" Then
                        Shortkeys.Rows(e.RowIndex).Cells(3).Value = KeyToSet.keyToSet.KeyData
                    Else
                        Select Case keyString
                            Case "Ctrl" : Shortkeys.Rows(e.RowIndex).Cells(3).Value = Keys.ControlKey
                            Case "Alt" : Shortkeys.Rows(e.RowIndex).Cells(3).Value = Keys.Menu
                            Case "Shift" : Shortkeys.Rows(e.RowIndex).Cells(3).Value = Keys.ShiftKey
                        End Select
                    End If
                End If
                End If
        End If
    End Sub

    Private Function keyToString(ByVal key As System.Windows.Forms.KeyEventArgs) As String
        Dim keyString As String = ""
        If key.Control Then
            keyString += "Ctrl+"
        End If
        If key.Shift Then
            keyString += "Shift+"
        End If
        If key.Alt Then
            keyString += "Alt+"
        End If
        keyString += key.KeyCode.ToString
        keyString = Replace(keyString, "D0", "0")
        keyString = Replace(keyString, "D1", "1")
        keyString = Replace(keyString, "D2", "2")
        keyString = Replace(keyString, "D3", "3")
        keyString = Replace(keyString, "D4", "4")
        keyString = Replace(keyString, "D5", "5")
        keyString = Replace(keyString, "D6", "6")
        keyString = Replace(keyString, "D7", "7")
        keyString = Replace(keyString, "D8", "8")
        keyString = Replace(keyString, "D9", "9")
        keyString = Replace(keyString, "Delete", "Del")
        keyString = Replace(keyString, "+ControlKey", "")
        keyString = Replace(keyString, "+ShiftKey", "")
        keyString = Replace(keyString, "+Menu", "")
        keyString = Replace(keyString, "Escape", "Esc")
        Return keyString
    End Function

    Private Sub BtnRestoreDefaults_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRestoreDefaults.Click
        Select Case TCOptions.SelectedIndex
            Case 0
                TBRealName.Text = ""
                TBUserName.Text = ""
                CBLicense.Text = ""
                NUDMaxUndo.Value = 30
                CBFullscreen.Checked = True
                CBPerformaceMode.Checked = False
                CBViewImage.Checked = True
                CBViewPreferences.Checked = True
                CBAlternativeZoomAndTrans.Checked = False
            Case 1
                Dim tRow As Byte = 1
                loadKeys()
                Shortkeys.Rows(tRow).Cells(1).Value = "Ctrl+N"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Control Or Keys.N : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "Ctrl+O"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Control Or Keys.O : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "Ctrl+S"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Control Or Keys.S : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "1"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.D1 : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "2"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.D2 : tRow += 1

                Shortkeys.Rows(tRow).Cells(1).Value = "3"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.D3 : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "4"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.D4 : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "5"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.D5 : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "6"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.D6 : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "F2"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.F2 : tRow += 1

                Shortkeys.Rows(tRow).Cells(1).Value = "F3"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.F3 : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "F4"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.F4 : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "F5"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.F5 : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "F6"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.F6 : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "P"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.P : tRow += 1

                Shortkeys.Rows(tRow).Cells(1).Value = "Space"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Space : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "O"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.O : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "Esc"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Escape : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "K"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.K : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "L"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.L : tRow += 1

                Shortkeys.Rows(tRow).Cells(1).Value = "Ctrl+R"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Control Or Keys.R : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "Ctrl+A"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Control Or Keys.A : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "Ctrl+Alt+C"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Control Or Keys.Alt Or Keys.C : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "Alt+C"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Alt Or Keys.C : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "Alt+T"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Alt Or Keys.T : tRow += 1

                Shortkeys.Rows(tRow).Cells(1).Value = "Alt+S"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Alt Or Keys.S : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "Ctrl+W"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Control Or Keys.W : tRow += 1
                Shortkeys.Rows(tRow).Cells(1).Value = "Ctrl+E"
                Shortkeys.Rows(tRow).Cells(3).Value = Keys.Control Or Keys.E : tRow += 1
            Case 2
                LTags.Items(0) = Color.FromArgb(0, 0, 0)
                PBack.BackColor = Color.FromArgb(0, 0, 0)
                LTags.Items(1) = New Pen(Color.FromArgb(234, 244, 234), 1)
                LTags.Items(2) = New Pen(Color.FromArgb(12, 12, 12), 1)
                LTags.Items(3) = New Pen(Color.FromArgb(245, 12, 12), 1)
                LTags.Items(4) = New Pen(Color.FromArgb(245, 180, 180), 1)
                LTags.Items(5) = New SolidBrush(Color.FromArgb(245, 245, 12))
                LTags.Items(6) = New SolidBrush(Color.FromArgb(245, 12, 12))
                LTags.Items(7) = New Pen(Color.FromArgb(140, 215, 140), 1)
                LTags.Items(8) = New Pen(Color.FromArgb(0, 60, 0), 1)
                LTags.Items(9) = New Pen(Color.FromArgb(60, 60, 105), 1)
                LTags.Items(10) = New Pen(Color.FromArgb(245, 245, 220), 1)
                LTags.Items(11) = New SolidBrush(Color.FromArgb(120, 0, 0))
                If LColours.SelectedIndex = 0 Then LColours.SelectedIndex = 1
                LColours.SelectedIndex = 0
        End Select
    End Sub

    Private Sub CBAlternativeZoomAndTrans_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CBAlternativeZoomAndTrans.CheckedChanged
        If Shortkeys.Rows.Count > 0 Then
            If CBAlternativeZoomAndTrans.Checked Then
                Shortkeys.Rows(0).Cells(0).Value = "Show context menue"
            Else
                Shortkeys.Rows(0).Cells(0).Value = "Show context menue / translate view"
            End If
        End If
    End Sub

    Dim active_channel As Byte

    Private Sub HR_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles HR.MouseEnter
        active_channel = 0
        PGradient.Refresh()
    End Sub

    Private Sub HR_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HR.Scroll
        Try
            PNew.BackColor = Color.FromArgb(HA.Value, HR.Value, HG.Value, HB.Value)
        Catch
            HR.Value = clip(HR.Value, 0, 255)
            HG.Value = clip(HG.Value, 0, 255)
            HB.Value = clip(HB.Value, 0, 255)
            HA.Value = clip(HA.Value, 0, 255)
        End Try
    End Sub

    Private Sub HG_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles HG.MouseEnter
        active_channel = 1
        PGradient.Refresh()
    End Sub

    Private Sub HG_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HG.Scroll
        Try
            PNew.BackColor = Color.FromArgb(HA.Value, HR.Value, HG.Value, HB.Value)
        Catch
            HR.Value = clip(HR.Value, 0, 255)
            HG.Value = clip(HG.Value, 0, 255)
            HB.Value = clip(HB.Value, 0, 255)
            HA.Value = clip(HA.Value, 0, 255)
        End Try
    End Sub

    Private Sub HB_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles HB.MouseEnter
        active_channel = 2
        PGradient.Refresh()
    End Sub

    Private Sub HB_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HB.Scroll
        Try
            PNew.BackColor = Color.FromArgb(HA.Value, HR.Value, HG.Value, HB.Value)
        Catch
            HR.Value = clip(HR.Value, 0, 255)
            HG.Value = clip(HG.Value, 0, 255)
            HB.Value = clip(HB.Value, 0, 255)
            HA.Value = clip(HA.Value, 0, 255)
        End Try
    End Sub

    Private Sub HA_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles HA.MouseEnter
        active_channel = 3
        PGradient.Refresh()
    End Sub

    Private Sub HA_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HA.Scroll
        Try
            PNew.BackColor = Color.FromArgb(HA.Value, HR.Value, HG.Value, HB.Value)
        Catch
            HR.Value = clip(HR.Value, 0, 255)
            HG.Value = clip(HG.Value, 0, 255)
            HB.Value = clip(HB.Value, 0, 255)
            HA.Value = clip(HA.Value, 0, 255)
        End Try
    End Sub

    Private Sub BtnApply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnApply.Click
        If LColours.SelectedIndex > -1 Then
            If TypeOf LTags.Items(LColours.SelectedIndex) Is Pen Then
                LTags.Items(LColours.SelectedIndex) = New Pen(Color.FromArgb(clip(HA.Value, 0, 255), clip(HR.Value, 0, 255), clip(HG.Value, 0, 255), clip(HB.Value, 0, 255)))
            ElseIf TypeOf LTags.Items(LColours.SelectedIndex) Is SolidBrush Then
                LTags.Items(LColours.SelectedIndex) = New SolidBrush(Color.FromArgb(clip(HA.Value, 0, 255), clip(HR.Value, 0, 255), clip(HG.Value, 0, 255), clip(HB.Value, 0, 255)))
            Else
                LTags.Items(LColours.SelectedIndex) = Color.FromArgb(clip(HA.Value, 0, 255), clip(HR.Value, 0, 255), clip(HG.Value, 0, 255), clip(HB.Value, 0, 255))
                PBack.BackColor = LTags.Items(LColours.SelectedIndex)
            End If
            POld.BackColor = Color.FromArgb(clip(HA.Value, 0, 255), clip(HR.Value, 0, 255), clip(HG.Value, 0, 255), clip(HB.Value, 0, 255))
        End If
    End Sub

    Private Function clip(ByRef value As Integer, ByVal min As Integer, ByVal max As Integer) As Integer
        value = Math.Max(value, min)
        value = Math.Min(value, max)
        Return value
    End Function

    Private Sub LColours_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LColours.SelectedIndexChanged
        If LColours.SelectedIndex > -1 Then
            If TypeOf LTags.Items(LColours.SelectedIndex) Is Pen Then
                POld.BackColor = CType(LTags.Items(LColours.SelectedIndex), Pen).Color
            ElseIf TypeOf LTags.Items(LColours.SelectedIndex) Is SolidBrush Then
                POld.BackColor = CType(LTags.Items(LColours.SelectedIndex), SolidBrush).Color
            Else
                POld.BackColor = CType(LTags.Items(LColours.SelectedIndex), Color)
            End If
            PNew.BackColor = POld.BackColor
            HR.Value = POld.BackColor.R
            HG.Value = POld.BackColor.G
            HB.Value = POld.BackColor.B
            HA.Value = POld.BackColor.A
            PGradient.Refresh()
            If LColours.SelectedIndex = 0 Then HA.Minimum = 200 Else HA.Minimum = 0
        End If
    End Sub

    Private Sub PGradient_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PGradient.Paint
        Select Case active_channel
            Case 0
                For x As Single = 0 To 200 Step 1.275
                    e.Graphics.FillRectangle(New SolidBrush(Color.FromArgb(clip(HA.Value, 0, 255), x * 1.275, clip(HG.Value, 0, 255), clip(HB.Value, 0, 255))), x, 0.0F, 1.275F, 20.0F)
                Next
            Case 1
                For x As Single = 0 To 200 Step 1.275
                    e.Graphics.FillRectangle(New SolidBrush(Color.FromArgb(clip(HA.Value, 0, 255), clip(HR.Value, 0, 255), x * 1.275, clip(HB.Value, 0, 255))), x, 0.0F, 1.275F, 20.0F)
                Next
            Case 2
                For x As Single = 0 To 200 Step 1.275
                    e.Graphics.FillRectangle(New SolidBrush(Color.FromArgb(clip(HA.Value, 0, 255), clip(HR.Value, 0, 255), clip(HG.Value, 0, 255), x * 1.275)), x, 0.0F, 1.275F, 20.0F)
                Next
            Case 3
                For x As Single = 0 To 200 Step 1.275
                    e.Graphics.FillRectangle(New SolidBrush(Color.FromArgb(x * 1.275, clip(HR.Value, 0, 255), clip(HG.Value, 0, 255), clip(HB.Value, 0, 255))), x, 0.0F, 1.275F, 20.0F)
                Next
        End Select
    End Sub

    Private Sub TCOptions_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TCOptions.SelectedIndexChanged
        If TCOptions.SelectedIndex = 2 Then
            If LColours.SelectedIndex = -1 Then
                LColours.SelectedIndex = 0
            End If
        End If
    End Sub

    Dim cr As Integer
    Dim cg As Integer
    Dim cb As Integer
    Dim ca As Integer
    Private Sub BtnCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCopy.Click
        cr = clip(HR.Value, 0, 255)
        cg = clip(HG.Value, 0, 255)
        cb = clip(HB.Value, 0, 255)
        ca = clip(HA.Value, 0, 255)
    End Sub


    Private Sub BtnPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPaste.Click
        HR.Value = cr
        HG.Value = cg
        HB.Value = cb
        HA.Value = ca
        PNew.BackColor = Color.FromArgb(ca, cr, cg, cb)
        PGradient.Refresh()
    End Sub

End Class

