﻿' MIT - Licence
'
' Copyright (c) 2010 - 2011 Nils Schmidt
' This program uses Rectifier.exe by permission of the author and copyright holder Philippe E. Hurbain - (C) 2009

' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
' to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
' and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

' The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
' PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
' FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
' ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Option Strict Off

Imports System.Windows.Forms

Public Class RingDialog

    Public hiRes As Boolean = False

    Public n As Double
    Public m As Double
    Public segments As Integer
    Public radius As Integer
    Public pname As String = ""

    Private ResFromRad As New Hashtable
    Private RadFromRes As New Hashtable
    Private HResFromRad As New Hashtable
    Private RadFromHRes As New Hashtable

    Dim oldName As String
    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        If CB48.Checked Then segments = 48 Else segments = 16

        Dim strs(1) As String
        Dim strs2(1) As String
        Dim temp As String = Replace(TBName.Text, ".dat", "")
        pname = TBName.Text
        temp = Replace(temp, "48\", "")
        If temp.Contains("ring") Then
            temp = Replace(temp, "ring", "%")
            strs = temp.Split(CType("%", Char))
        End If
        If temp.Contains("rin") Then
            temp = Replace(temp, "rin", "%")
            strs = temp.Split(CType("%", Char))
        End If
        If temp.Contains("ri") Then
            temp = Replace(temp, "ri", "%")
            strs = temp.Split(CType("%", Char))
        End If
        strs2 = strs(0).Split(CType("-", Char))
        n = CType(strs2(0), Double)
        m = CType(strs2(1), Double)
        radius = CType(strs(1), Integer)
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub RingDialog_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown

        CBRadius.Items.Clear()
        CBResolution.Items.Clear()

        If CBName.Items.Count = 0 Then
            CBName.Items.Add("1-16rin1")
            CBName.Items.Add("1-8ring1")
            CBName.Items.Add("3-16rin1")
            CBName.Items.Add("1-4ring1")
            CBName.Items.Add("3-8ring1")
            CBName.Items.Add("2-4ring1")
            CBName.Items.Add("5-8ring1")
            CBName.Items.Add("3-4ring1")
            CBName.Items.Add("7-8ring1")
            CBName.Items.Add("4-4ring1")
            CBName.Items.Add("1-16rin2")
            CBName.Items.Add("1-8ring2")
            CBName.Items.Add("3-16rin2")
            CBName.Items.Add("1-4ring2")
            CBName.Items.Add("3-8ring2")
            CBName.Items.Add("2-4ring2")
            CBName.Items.Add("5-8ring2")
            CBName.Items.Add("3-4ring2")
            CBName.Items.Add("4-4ring2")
            CBName.Items.Add("1-16rin3")
            CBName.Items.Add("1-8ring3")
            CBName.Items.Add("3-16rin3")
            CBName.Items.Add("1-4ring3")
            CBName.Items.Add("3-8ring3")
            CBName.Items.Add("7-16rin3")
            CBName.Items.Add("2-4ring3")
            CBName.Items.Add("3-4ring3")
            CBName.Items.Add("4-4ring3")
            CBName.Items.Add("1-8ring4")
            CBName.Items.Add("3-16rin4")
            CBName.Items.Add("1-4ring4")
            CBName.Items.Add("3-8ring4")
            CBName.Items.Add("7-16rin4")
            CBName.Items.Add("2-4ring4")
            CBName.Items.Add("3-4ring4")
            CBName.Items.Add("4-4ring4")
            CBName.Items.Add("1-8ring5")
            CBName.Items.Add("3-16rin5")
            CBName.Items.Add("1-4ring5")
            CBName.Items.Add("3-8ring5")
            CBName.Items.Add("2-4ring5")
            CBName.Items.Add("4-4ring5")
            CBName.Items.Add("1-8ring6")
            CBName.Items.Add("1-4ring6")
            CBName.Items.Add("3-8ring6")
            CBName.Items.Add("2-4ring6")
            CBName.Items.Add("5-8ring6")
            CBName.Items.Add("4-4ring6")
            CBName.Items.Add("1-4ring7")
            CBName.Items.Add("3-8ring7")
            CBName.Items.Add("2-4ring7")
            CBName.Items.Add("3-4ring7")
            CBName.Items.Add("4-4ring7")
            CBName.Items.Add("1-8ring8")
            CBName.Items.Add("1-4ring8")
            CBName.Items.Add("3-8ring8")
            CBName.Items.Add("2-4ring8")
            CBName.Items.Add("3-4ring8")
            CBName.Items.Add("4-4ring8")
            CBName.Items.Add("1-8ring9")
            CBName.Items.Add("3-16rin9")
            CBName.Items.Add("1-4ring9")
            CBName.Items.Add("3-8ring9")
            CBName.Items.Add("2-4ring9")
            CBName.Items.Add("4-4ring9")
            CBName.Items.Add("1-8rin10")
            CBName.Items.Add("1-4rin10")
            CBName.Items.Add("3-8rin10")
            CBName.Items.Add("2-4rin10")
            CBName.Items.Add("3-4rin10")
            CBName.Items.Add("4-4rin10")
            CBName.Items.Add("3-16ri11")
            CBName.Items.Add("1-4rin11")
            CBName.Items.Add("2-4rin11")
            CBName.Items.Add("4-4rin11")
            CBName.Items.Add("1-4rin12")
            CBName.Items.Add("3-8rin12")
            CBName.Items.Add("2-4rin12")
            CBName.Items.Add("4-4rin12")
            CBName.Items.Add("1-4rin13")
            CBName.Items.Add("2-4rin13")
            CBName.Items.Add("4-4rin13")
            CBName.Items.Add("1-4rin14")
            CBName.Items.Add("2-4rin14")
            CBName.Items.Add("4-4rin14")
            CBName.Items.Add("1-8rin15")
            CBName.Items.Add("1-4rin15")
            CBName.Items.Add("2-4rin15")
            CBName.Items.Add("7-8rin15")
            CBName.Items.Add("4-4rin15")
            CBName.Items.Add("1-4rin16")
            CBName.Items.Add("3-8rin16")
            CBName.Items.Add("2-4rin16")
            CBName.Items.Add("7-8rin16")
            CBName.Items.Add("4-4rin16")
            CBName.Items.Add("1-8rin17")
            CBName.Items.Add("1-4rin17")
            CBName.Items.Add("2-4rin17")
            CBName.Items.Add("4-4rin17")
            CBName.Items.Add("1-8rin18")
            CBName.Items.Add("1-4rin18")
            CBName.Items.Add("3-8rin18")
            CBName.Items.Add("4-4rin18")
            CBName.Items.Add("1-8rin19")
            CBName.Items.Add("1-4rin19")
            CBName.Items.Add("4-4rin19")
            CBName.Items.Add("4-4rin20")
            CBName.Items.Add("4-4rin21")
            CBName.Items.Add("2-4rin22")
            CBName.Items.Add("4-4rin22")
            CBName.Items.Add("1-8rin23")
            CBName.Items.Add("2-4rin23")
            CBName.Items.Add("4-4rin23")
            CBName.Items.Add("1-4rin24")
            CBName.Items.Add("2-4rin24")
            CBName.Items.Add("4-4rin24")
            CBName.Items.Add("2-4rin25")
            CBName.Items.Add("4-4rin25")
            CBName.Items.Add("1-4rin28")
            CBName.Items.Add("4-4rin29")
            CBName.Items.Add("2-4rin30")
            CBName.Items.Add("4-4rin34")
            CBName.Items.Add("4-4rin36")
            CBName.Items.Add("1-4rin38")
            CBName.Items.Add("4-4rin38")
            CBName.Items.Add("1-4rin39")
            CBName.Items.Add("4-4rin39")
            CBName.Items.Add("4-4rin46")
            CBName.Items.Add("4-4rin47")
            CBName.Items.Add("4-4rin50")
            CBName.Items.Add("4-4rin51")
            CBName.Items.Add("2-4rin52")
            CBName.Items.Add("4-4rin52")
            CBName.Items.Add("4-4rin57")
            CBName.Items.Add("4-4rin77")
            CBName.Items.Add("4-4rin78")
            CBName.Items.Add("4-4rin79")

            CBName.Items.Add("48\1-12rin1")
            CBName.Items.Add("48\1-8ring1")
            CBName.Items.Add("48\1-6ring1")
            CBName.Items.Add("48\1-4ring1")
            CBName.Items.Add("48\2-4ring1")
            CBName.Items.Add("48\1-12rin2")
            CBName.Items.Add("48\1-8ring2")
            CBName.Items.Add("48\1-4ring2")
            CBName.Items.Add("48\2-4ring2")
            CBName.Items.Add("48\4-4ring2")
            CBName.Items.Add("48\1-8ring3")
            CBName.Items.Add("48\1-6ring3")
            CBName.Items.Add("48\1-4ring3")
            CBName.Items.Add("48\2-4ring3")
            CBName.Items.Add("48\4-4ring3")
            CBName.Items.Add("48\1-8ring4")
            CBName.Items.Add("48\1-4ring4")
            CBName.Items.Add("48\2-4ring4")
            CBName.Items.Add("48\4-4ring4")
            CBName.Items.Add("48\1-12rin5")
            CBName.Items.Add("48\1-8ring5")
            CBName.Items.Add("48\1-6ring5")
            CBName.Items.Add("48\1-4ring5")
            CBName.Items.Add("48\2-4ring5")
            CBName.Items.Add("48\4-4ring5")
            CBName.Items.Add("48\1-8ring6")
            CBName.Items.Add("48\2-4ring6")
            CBName.Items.Add("48\4-4ring6")
            CBName.Items.Add("48\1-8ring7")
            CBName.Items.Add("48\3-16rin7")
            CBName.Items.Add("48\3-4ring7")
            CBName.Items.Add("48\4-4ring7")
            CBName.Items.Add("48\1-8ring8")
            CBName.Items.Add("48\1-6ring8")
            CBName.Items.Add("48\1-4ring8")
            CBName.Items.Add("48\4-4ring8")
            CBName.Items.Add("48\1-48rin9")
            CBName.Items.Add("48\5-48rin9")
            CBName.Items.Add("48\1-8ring9")
            CBName.Items.Add("48\5-24rin9")
            CBName.Items.Add("48\1-4ring9")
            CBName.Items.Add("48\4-4ring9")
            CBName.Items.Add("48\1-4rin10")
            CBName.Items.Add("48\4-4rin10")
            CBName.Items.Add("48\1-4rin11")
            CBName.Items.Add("48\2-4rin11")
            CBName.Items.Add("48\4-4rin11")
            CBName.Items.Add("48\1-6rin12")
            CBName.Items.Add("48\2-4rin12")
            CBName.Items.Add("48\4-4rin12")
            CBName.Items.Add("48\1-16ri13")
            CBName.Items.Add("48\1-6rin13")
            CBName.Items.Add("48\3-4rin13")
            CBName.Items.Add("48\4-4rin13")
            CBName.Items.Add("48\1-16ri14")
            CBName.Items.Add("48\1-6rin14")
            CBName.Items.Add("48\3-4rin14")
            CBName.Items.Add("48\4-4rin14")
            CBName.Items.Add("48\1-4rin15")
            CBName.Items.Add("48\4-4rin15")
            CBName.Items.Add("48\1-4rin16")
            CBName.Items.Add("48\3-4rin16")
            CBName.Items.Add("48\4-4rin16")
            CBName.Items.Add("48\1-6rin17")
            CBName.Items.Add("48\1-4rin17")
            CBName.Items.Add("48\2-4rin17")
            CBName.Items.Add("48\4-4rin17")
            CBName.Items.Add("48\4-4rin18")
            CBName.Items.Add("48\1-4rin19")
            CBName.Items.Add("48\4-4rin19")
            CBName.Items.Add("48\1-4rin20")
            CBName.Items.Add("48\1-4rin21")
            CBName.Items.Add("48\4-4rin21")
            CBName.Items.Add("48\1-4rin22")
            CBName.Items.Add("48\4-4rin22")
            CBName.Items.Add("48\1-4rin23")
            CBName.Items.Add("48\1-4rin24")
            CBName.Items.Add("48\4-4rin24")
            CBName.Items.Add("48\1-4rin25")
            CBName.Items.Add("48\1-4rin26")
            CBName.Items.Add("48\4-4rin26")
            CBName.Items.Add("48\1-4rin27")
            CBName.Items.Add("48\4-4rin27")
            CBName.Items.Add("48\1-8rin28")
            CBName.Items.Add("48\4-4rin28")
            CBName.Items.Add("48\1-4rin29")
            CBName.Items.Add("48\4-4rin29")
            CBName.Items.Add("48\1-4rin30")
            CBName.Items.Add("48\4-4rin30")
            CBName.Items.Add("48\2-4rin31")
            CBName.Items.Add("48\1-4rin32")
            CBName.Items.Add("48\5-48ri32")
            CBName.Items.Add("48\1-4rin33")
            CBName.Items.Add("48\4-4rin33")
            CBName.Items.Add("48\1-4rin34")
            CBName.Items.Add("48\1-8rin35")
            CBName.Items.Add("48\1-4rin35")
            CBName.Items.Add("48\1-4rin36")
            CBName.Items.Add("48\1-4rin37")
            CBName.Items.Add("48\4-4rin37")
            CBName.Items.Add("48\1-8rin39")
            CBName.Items.Add("48\1-4rin39")
            CBName.Items.Add("48\1-4rin41")
            CBName.Items.Add("48\1-4rin45")
            CBName.Items.Add("48\4-4rin47")
            CBName.Items.Add("48\1-4rin48")
            CBName.Items.Add("48\1-4rin51")
            CBName.Items.Add("48\4-4rin52")
            CBName.Items.Add("48\4-4rin53")
            CBName.Items.Add("48\4-4rin54")
            CBName.Items.Add("48\1-8rin56")
            CBName.Items.Add("48\1-4rin63")
            CBName.Items.Add("48\1-4rin64")
            CBName.Items.Add("48\1-4rin65")
            CBName.Items.Add("48\1-4rin70")
            CBName.Items.Add("48\1-4rin71")
            CBName.Items.Add("48\1-4rin82")
        End If

        fillLists()

    End Sub

    Private Sub fillLists()
        If RadFromRes.Count = 0 Then
            For Each temp As String In CBName.Items
                Dim strs(1) As String
                Dim p48 As Boolean
                p48 = temp.Contains("48\")
                If p48 Then
                    temp = Replace(temp, "48\", "")
                End If
                If temp.Contains("ring") Then
                    temp = Replace(temp, "ring", "%")
                    strs = temp.Split(CType("%", Char))
                End If
                If temp.Contains("rin") Then
                    temp = Replace(temp, "rin", "%")
                    strs = temp.Split(CType("%", Char))
                End If
                If temp.Contains("ri") Then
                    temp = Replace(temp, "ri", "%")
                    strs = temp.Split(CType("%", Char))
                End If
                If strs(1).Length = 1 Then strs(1) = " " & strs(1)
                If strs(0).Length = 4 Then strs(0) = " " & strs(0)
                If strs(0).Length = 3 Then strs(0) = "  " & strs(0)
                If p48 Then
                    If HResFromRad.Contains(strs(1)) Then HResFromRad(strs(1)).Add(strs(0)) Else HResFromRad.Add(strs(1), New List(Of String)) : HResFromRad(strs(1)).Add(strs(0))
                    If RadFromHRes.Contains(strs(0)) Then RadFromHRes(strs(0)).Add(strs(1)) Else RadFromHRes.Add(strs(0), New List(Of String)) : RadFromHRes(strs(0)).Add(strs(1))
                Else
                    If ResFromRad.Contains(strs(1)) Then ResFromRad(strs(1)).Add(strs(0)) Else ResFromRad.Add(strs(1), New List(Of String)) : ResFromRad(strs(1)).Add(strs(0))
                    If RadFromRes.Contains(strs(0)) Then RadFromRes(strs(0)).Add(strs(1)) Else RadFromRes.Add(strs(0), New List(Of String)) : RadFromRes(strs(0)).Add(strs(1))
                End If
                CBRadius.Text = strs(1)
                CBResolution.Text = strs(0)
            Next

            CBRadius.Text = " 1"
        End If

        CBRadius.Items.Clear()
        CBResolution.Items.Clear()

        CB48.Checked = hiRes

        If CBRadius.Items.Count = 0 Then
            If CB48.Checked Then
                For Each key As String In HResFromRad.Keys
                    CBRadius.Items.Add(key)
                    For Each res As String In HResFromRad(key)
                        If Not CBResolution.Items.Contains(res) Then CBResolution.Items.Add(res)
                    Next
                Next
            Else
                For Each key As String In ResFromRad.Keys
                    CBRadius.Items.Add(key)
                    For Each res As String In ResFromRad(key)
                        If Not CBResolution.Items.Contains(res) Then CBResolution.Items.Add(res)
                    Next
                Next
            End If
        End If
    End Sub


    Private Sub getDataFromName()
        If CBName.Items.Contains(CBName.Text) Then
            Dim strs(1) As String
            Dim temp As String = CBName.Text
            CB48.Checked = temp.Contains("48\")
            If CB48.Checked Then
                temp = Replace(temp, "48\", "")
            End If
            If temp.Contains("ring") Then
                temp = Replace(temp, "ring", "%")
                strs = temp.Split(CType("%", Char))
            End If
            If temp.Contains("rin") Then
                temp = Replace(temp, "rin", "%")
                strs = temp.Split(CType("%", Char))
            End If
            If temp.Contains("ri") Then
                temp = Replace(temp, "ri", "%")
                strs = temp.Split(CType("%", Char))
            End If
            If strs(1).Length = 1 Then strs(1) = " " & strs(1)
            If strs(0).Length = 4 Then strs(0) = " " & strs(0)
            If strs(0).Length = 3 Then strs(0) = "  " & strs(0)
            CBRadius.Text = strs(1)
            CBResolution.Text = strs(0)
            CBName.BackColor = Color.White
            CBName.ForeColor = Color.Black
            CBResolution.BackColor = Color.White
            CBResolution.ForeColor = Color.Black
            CBRadius.BackColor = Color.White
            CBRadius.ForeColor = Color.Black
        Else
            CBName.BackColor = Color.White
            CBName.ForeColor = Color.Red
        End If
    End Sub


    Private Sub CBName_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CBName.SelectedIndexChanged
        getDataFromName()
    End Sub

    Private Sub CB48_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CB48.CheckedChanged
        CBRadius.Items.Clear()
        CBResolution.Items.Clear()

        Dim sep As String = "ring"
        sep = Trim(CBResolution.Text) & Mid(sep, 1, 12 - (Trim(CBResolution.Text) & sep & Trim(CBRadius.Text)).Length) & Trim(CBRadius.Text)

        If CB48.Checked Then
            CBName.Text = "48\" & sep
            For Each key As String In HResFromRad.Keys
                CBRadius.Items.Add(key)
                For Each res As String In HResFromRad(key)
                    If Not CBResolution.Items.Contains(res) Then CBResolution.Items.Add(res)
                Next
            Next
        Else
            CBName.Text = sep
            For Each key As String In ResFromRad.Keys
                CBRadius.Items.Add(key)
                For Each res As String In ResFromRad(key)
                    If Not CBResolution.Items.Contains(res) Then CBResolution.Items.Add(res)
                Next
            Next
        End If

        If CBName.Items.Contains(CBName.Text) Then
            TBName.Text = CBName.Text & ".dat"
            CBName.BackColor = Color.White
            CBName.ForeColor = Color.Black
        Else
            TBName.Text = "Nonexisting primitive."
            CBName.BackColor = Color.White
            CBName.ForeColor = Color.Red
        End If
    End Sub

    Private Sub CBRadius_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CBRadius.SelectedIndexChanged

        CBResolution.Items.Clear()
        Dim sep As String = "ring"
        sep = Trim(CBResolution.Text) & Mid(sep, 1, 12 - (Trim(CBResolution.Text) & sep & Trim(CBRadius.Text)).Length) & Trim(CBRadius.Text)


        If CB48.Checked Then
            CBName.Text = "48\" & sep
            For Each res As String In HResFromRad(CBRadius.Text)
                If Not CBResolution.Items.Contains(res) Then CBResolution.Items.Add(res)
            Next
        Else
            CBName.Text = sep
            For Each res As String In ResFromRad(CBRadius.Text)
                If Not CBResolution.Items.Contains(res) Then CBResolution.Items.Add(res)
            Next
        End If
        If CBResolution.Items.Contains(CBResolution.Text) Then
            CBResolution.BackColor = Color.White
            CBResolution.ForeColor = Color.Black
        Else
            CBResolution.BackColor = Color.White
            CBResolution.ForeColor = Color.Red
        End If
        If CBName.Items.Contains(CBName.Text) Then
            TBName.Text = CBName.Text & ".dat"
            CBName.BackColor = Color.White
            CBName.ForeColor = Color.Black
        Else
            TBName.Text = "Nonexisting primitive."
            CBName.BackColor = Color.White
            CBName.ForeColor = Color.Red
        End If

    End Sub

    Private Sub CBResolution_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CBResolution.SelectedIndexChanged
        CBRadius.Items.Clear()
        Dim sep As String = "ring"
        sep = Trim(CBResolution.Text) & Mid(sep, 1, 12 - (Trim(CBResolution.Text) & sep & Trim(CBRadius.Text)).Length) & Trim(CBRadius.Text)


        If CB48.Checked Then
            CBName.Text = "48\" & sep
            For Each res As String In RadFromHRes(CBResolution.Text)
                If Not CBRadius.Items.Contains(res) Then CBRadius.Items.Add(res)
            Next
        Else
            CBName.Text = sep
            For Each res As String In RadFromRes(CBResolution.Text)
                If Not CBRadius.Items.Contains(res) Then CBRadius.Items.Add(res)
            Next
        End If
        If CBRadius.Items.Contains(CBRadius.Text) Then
            CBRadius.BackColor = Color.White
            CBRadius.ForeColor = Color.Black
        Else
            CBRadius.BackColor = Color.White
            CBRadius.ForeColor = Color.Red
        End If
        If CBName.Items.Contains(CBName.Text) Then
            TBName.Text = CBName.Text & ".dat"
            CBName.BackColor = Color.White
            CBName.ForeColor = Color.Black
        Else
            TBName.Text = "Nonexisting primitive."
            CBName.BackColor = Color.White
            CBName.ForeColor = Color.Red
        End If
    End Sub

    Private Sub TBName_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TBName.TextChanged
        OK_Button.Enabled = Not TBName.Text = "Nonexisting primitive."
    End Sub
End Class
