﻿'///////////
'//PowerRay 1.00 - Klasse für Strahl-Dreieck-Schnittpunktberechnung
'//(c) Nils Schmidt 2008-2009
'///////////
Public Class PowerRay
    Public Shared t, u, v As Decimal
    Const TOLERANZ As Single = 0.000001


    Shared Function KREUZ(ByVal v1() As Decimal, ByVal v2() As Decimal) As Decimal() 'Kreuzprodukt
        Dim kreuzVektor(2) As Decimal
        kreuzVektor(0) = v1(1) * v2(2) - v1(2) * v2(1)
        kreuzVektor(1) = v1(2) * v2(0) - v1(0) * v2(2)
        kreuzVektor(2) = v1(0) * v2(1) - v1(1) * v2(0)
        Return kreuzVektor
    End Function

    Shared Function VPR(ByVal v1() As Decimal, ByVal v2() As Decimal) As Decimal 'Vektorprodukt
        Return v1(0) * v2(0) + v1(1) * v2(1) + v1(2) * v2(2)
    End Function

    Shared Function SUBST(ByVal v1() As Decimal, ByVal v2() As Decimal) As Decimal() 'Vektorsubtraktion
        Dim subVektor(2) As Decimal
        subVektor(0) = v1(0) - v2(0)
        subVektor(1) = v1(1) - v2(1)
        subVektor(2) = v1(2) - v2(2)
        Return subVektor
    End Function

    Shared Function SCHNITTPKT_DREIECK(ByVal orig() As Decimal, ByVal dir() As Decimal, _
    ByVal vert0() As Decimal, ByVal vert1() As Decimal, ByVal vert2() As Decimal) As Boolean
        Dim ecke1(3), ecke2(3), tvec(3), pvec(3), qvec(3) As Decimal
        Dim diskr As Decimal = 0 : Dim inv_diskr As Decimal = 0

        'Setze Eckenvektoren AB AC
        ecke1 = SUBST(vert1, vert0)
        ecke2 = SUBST(vert2, vert0)

        'Berechne Diskriminante
        pvec = KREUZ(dir, ecke2)
        diskr = VPR(ecke1, pvec)

        'Prüfe Diskriminante um Division durch Null zu vermeiden
        If (diskr > -TOLERANZ And diskr < TOLERANZ) Then Return False
        inv_diskr = 1 / diskr

        'Abstand zwischen vert0 zu Strahl-Ursprung
        tvec = SUBST(orig, vert0)

        'Berechne den "ersten" baryzentrischen Parameter u
        u = VPR(tvec, pvec) * inv_diskr
        If u < 0 Or u > 1 Then Return False

        'Paramter v vorbereiten
        qvec = KREUZ(tvec, ecke1)

        'Berechne den "zweiten" baryzentrischen Parameter v
        v = VPR(dir, qvec) * inv_diskr
        If v < 0 Or u + v > 1 Then Return False

        'Berechne den "dritten" baryzentrischen Parameter t
        t = VPR(ecke2, qvec) * inv_diskr
        If t < 0 Then Return False
        'Strahl schneidet Dreieck!
        Return True
    End Function

End Class

